<?php
/**
 * Init function
 */
if (!function_exists('otw_bmp_widgets_init')) {
    function otw_bmp_widgets_init()
    {
        global $otw_components;

        if (isset($otw_components['registered']) && isset($otw_components['registered']['otw_shortcode'])) {
            $shortcode_components = $otw_components['registered']['otw_shortcode'];
            arsort($shortcode_components);

            foreach ($shortcode_components as $shortcode) {
                if (is_file($shortcode['path'] . '/widgets/otw_shortcode_widget.class.php')) {
                    include_once($shortcode['path'] . '/widgets/otw_shortcode_widget.class.php');
                    break;
                }
            }
        }
        register_widget('OTW_Shortcode_Widget');
    }
}
/**
 * Init function
 */
if (!function_exists('otw_bmp_init')) {
    function otw_bmp_init()
    {
        global $otw_bmp_plugin_url,
               $otw_bmp_plugin_options,
               $otw_bmp_shortcode_component,
               $otw_bmp_shortcode_object,
               $otw_bmp_form_component,
               $otw_bmp_validator_component,
               $otw_bmp_form_object,
               $otw_bmp_skin,
               $wp_bmp_cs_items,
               $buttonTypes,
               $chosenButtonType,
               $otw_bmp_name,
               $otwPluginDevName, $otw_bmp_plugin_id, $otw_bmp_factory_object;

        if (is_admin()) {
            add_action('admin_menu', $otwPluginDevName . '_init_admin_menu');
            add_action('admin_print_styles', $otwPluginDevName . '_enqueue_admin_styles');
            add_action('admin_enqueue_scripts', $otwPluginDevName . '_enqueue_admin_scripts');
            add_filter( 'otwfcr_notice', 'otw_bmp_factory_message' );
        }
        otw_bmp_enqueue_styles();

        //shortcode component
        $otw_bmp_shortcode_component = otw_load_component('otw_shortcode');
        $otw_bmp_shortcode_object = otw_get_component($otw_bmp_shortcode_component);
        $otw_bmp_shortcode_object->editor_button_active_for['page'] = true;
        $otw_bmp_shortcode_object->editor_button_active_for['post'] = true;

        // $otw_bmp_shortcode_object->add_default_external_lib('css', 'style', get_stylesheet_directory_uri() . '/style.css', 'live_preview', 10);

//        $buttonsChildren = false;
//        foreach($buttonTypes as $buttonData) {
//            $otw_bmp_shortcode_object->shortcodes[$buttonData['id']] = array(
//                'title' => $buttonData['title'],
//                'enabled' => true,
//                'children' => false,
//                'parent' => false,
//                'order' => 0,
//                'path' => dirname(__FILE__) . '/otw_components/otw_shortcode/',
//                'url' => $otw_bmp_plugin_url . '/include/otw_components/otw_shortcode/',
//                'dialog_text' => '',
//            );
//            $buttonsChildren[] = $buttonData['id'];
//        }

        $otw_bmp_shortcode_object->shortcodes['otw_bmp'] = array(
            'title' => __('Buttons Mega Pack', $otwPluginDevName),
            'enabled' => true,
            'children' => false,
            'parent' => false,
            'order' => 0,
            'path' => dirname(__FILE__) . '/otw_components/otw_shortcode/',
            'url' => $otw_bmp_plugin_url . 'include/otw_components/otw_shortcode/',
            'dialog_text' => '',
        );

	$otw_bmp_factory_component = otw_load_component( 'otw_factory' );
	$otw_bmp_factory_object = otw_get_component( $otw_bmp_factory_component );
	$otw_bmp_factory_object->add_plugin( $otw_bmp_plugin_id, dirname( dirname( __FILE__ ) ).'/otw_buttons_mega_pack.php', array( 'menu_parent' => 'otw-bmp-list', 'lc_name' => __( 'License Manager', 'otw_bmp' ), 'menu_key' => 'otw-bmp' ) );
	
	include_once( plugin_dir_path( __FILE__ ).'otw_labels/otw_bmp_factory_object.labels.php' );
	$otw_bmp_factory_object->init();
	
        include_once(plugin_dir_path(__FILE__) . 'otw_labels/' . $otwPluginDevName . '_shortcode_object.labels.php');
        if( $otw_bmp_factory_object->is_plugin_active( $otw_bmp_plugin_id ) ){
    	    $otw_bmp_shortcode_object->init();
        }

        //form component
        $otw_bmp_form_component = otw_load_component('otw_form');
        $otw_bmp_form_object = otw_get_component($otw_bmp_form_component);
        include_once(plugin_dir_path(__FILE__) . 'otw_labels/' . $otwPluginDevName . '_form_object.labels.php');
        $otw_bmp_form_object->init();

        //validator component
        $otw_bmp_validator_component = otw_load_component('otw_validator');
        $otw_bmp_validator_object = otw_get_component($otw_bmp_validator_component);
        $otw_bmp_validator_object->init();

	if( is_admin() ){
		
		if( $otw_bmp_factory_object->is_plugin_active( $otw_bmp_plugin_id ) ){
			include_once($otwPluginDevName . '_process_actions.php');
		}
	}
    }
}

/**
 * include needed styles
 */
if (!function_exists('otw_bmp_enqueue_styles')) {
	function otw_bmp_enqueue_styles(){
		
		global $otw_bmp_plugin_url, $otw_bmp_css_version, $otw_bmp_custom_css_path,  $otw_bmp_custom_css_url;
		
		if( !is_admin() ){
			
			if( file_exists( $otw_bmp_custom_css_path ) ){
				
				wp_register_style('otw_bmp_custom.css', $otw_bmp_custom_css_url );
				wp_enqueue_style('otw_bmp_custom.css');
			}
		}
	}
}


/**
 * Admin styles
 */
if (!function_exists('otw_bmp_enqueue_admin_styles')) {

    function otw_bmp_enqueue_admin_styles()
    {

        global $otw_bmp_plugin_url, $otwPluginDevName;

        $currentScreen = get_current_screen();

        switch ($currentScreen->id) {

            case 'widgets':
            case 'page':
            case 'post':
                wp_enqueue_style($otwPluginDevName . '_admin', $otw_bmp_plugin_url . 'css/' . $otwPluginDevName . '_admin.css', array('thickbox'), OTW_BMP_PLUGIN_VERSION);
                break;
        }
    }
}


/**
 * Admin scripts
 */
if (!function_exists('otw_bmp_enqueue_admin_scripts')) {

    function otw_bmp_enqueue_admin_scripts($requested_page)
    {

        global $otw_bmp_plugin_url, $otw_bmp_js_version;

        switch ($requested_page) {

            case 'widgets.php':
                wp_enqueue_script("otw_shotcode_widget_admin", $otw_bmp_plugin_url . 'include/otw_components/otw_shortcode/js/otw_shortcode_widget_admin.js', array(
                    'jquery',
                    'thickbox'
                ), $otw_bmp_js_version);

                if (function_exists('wp_enqueue_media')) {
                    wp_enqueue_media();
                } else {
                    wp_enqueue_style('thickbox');
                    wp_enqueue_script('media-upload');
                    wp_enqueue_script('thickbox');
                }
                break;
        }
    }

}

/**
 * Init admin menu
 */
if (!function_exists('otw_bmp_init_admin_menu')) {
	
	function otw_bmp_init_admin_menu(){
		
		global $otw_bmp_plugin_url, $buttonTypes, $otw_bmp_name, $otwPluginDevName, $otw_bmp_plugin_id, $otw_bmp_factory_object;;
		
		add_menu_page( __('Buttons Mega Pack', $otwPluginDevName), __('Buttons Mega Pack', $otwPluginDevName), 'manage_options', $otw_bmp_name . '-list',         $otwPluginDevName . '_list', $otw_bmp_plugin_url . 'images/' . $otw_bmp_name . '-icon.png' );
		if( $otw_bmp_factory_object->is_plugin_active( $otw_bmp_plugin_id ) ){
			add_submenu_page( $otw_bmp_name . '-list', __('List', $otwPluginDevName), __('List', $otwPluginDevName), 'manage_options', $otw_bmp_name . '-list',    $otwPluginDevName . '_list' );
			add_submenu_page( $otw_bmp_name . '-list', __('Add button', $otwPluginDevName), __('Add button', $otwPluginDevName), 'manage_options', $otw_bmp_name . '-add', $otwPluginDevName . '_add' );
			add_submenu_page( $otw_bmp_name . '-list', __('Settings', $otwPluginDevName), __('Settings', $otwPluginDevName), 'manage_options', $otw_bmp_name . '-settings', $otwPluginDevName . '_settings' );
		}
	}
}

/**
 * List page
 */
if (!function_exists('otw_bmp_list')) {

    function otw_bmp_list()
    {
        global $otwPluginDevName;
        require_once($otwPluginDevName . '_list.php');
    }
}

/**
 * Add new page
 */
if (!function_exists('otw_bmp_add')) {

    function otw_bmp_add()
    {
        global $otwPluginDevName;
        require_once($otwPluginDevName . '_add.php');
    }
}

/**
 * Delete page
 */
if (!function_exists('otw_bmp_delete')) {

    function otw_bmp_delete()
    {
        global $otwPluginDevName;
        require_once($otwPluginDevName . '_delete.php');
    }
}

/**
 * Settings page
 */
if (!function_exists('otw_bmp_settings')) {
	
	function otw_bmp_settings(){
		global $otwPluginDevName, $otw_bmp_custom_css_path;
		
		$customCss = '';
		
		if( file_exists( $otw_bmp_custom_css_path ) ){
			$customCss = file_get_contents( $otw_bmp_custom_css_path );
		}
		
		require_once($otwPluginDevName . '_settings.php');
	}
}

/**
 * Get OTW Buttons
 */
if (!function_exists('otw_get_buttons')) {
    function otw_get_buttons($buttonType = false)
    {
        global $optionName;
        $otw_bmp_list = get_option($optionName);

        if (!is_array($otw_bmp_list) || !count($otw_bmp_list)) {
            $otw_bmp_list = array();
        } else {
            if ($buttonType !== false && is_string($buttonType)) {
                foreach ($otw_bmp_list as $buttonId => $button) {
                    if ($button['type'] != $buttonType) {
                        unset($otw_bmp_list[$buttonId]);
                    }
                }
            }
        }
        return $otw_bmp_list;
    }
}

/**
 * get button next id
 */
if (!function_exists('otw_get_next_button_id')) {
    function otw_get_next_button_id()
    {
        $next_id = 1;
        $existing_buttons = otw_get_buttons();

        if (is_array($existing_buttons) && count($existing_buttons)) {
            foreach ($existing_buttons as $buttonId => $button) {
                if (preg_match("/^([0-9]+)$/", $buttonId, $matches)) {
                    if ($matches[1] > $next_id) {
                        $next_id = $matches[1];
                    }
                }
            }
        } else {
            $next_id = 0;
        }
        return $next_id + 1;

    }
}

/**
 * Prepare data for add/edit form
 */
if (!function_exists('otw_prepare_data')) {
    function otw_prepare_data()
    {
        global $chosenButtonType, $otw_bmp_name, $content, $otw_bmp_list;

        // Init OTW BMP option
        $otw_bmp_list = otw_get_buttons($chosenButtonType);
        if (isset($_GET[$otw_bmp_name . '-id'])
            && isset($otw_bmp_list[$_GET[$otw_bmp_name . '-id']])
        ) {
            // TODO - figure out this
            foreach ($otw_bmp_list[$_GET[$otw_bmp_name . '-id']] as $buttonName => $buttonData) {
                $content[$buttonName] = $buttonData;
                if (isset($_POST) && isset($_POST[$buttonName])) {
                    $content[$buttonName] = $_POST[$buttonName];
                }
            }
        }
    }
}

if (!function_exists('otw_admin_text')) {
    function otw_admin_text($content, $sectionElementKey, $sectionElement, $config = array())
    {
        $return = '
        <tr valign="top">
            <th scope="row">
                <label for="' . $sectionElement['id'] . '">' . $sectionElement['label'] . '</label>
            </th>
        <td>';
        $params = array(
            'id' => $sectionElement['id'],
            'name' => $sectionElement['name'],
            'parse' => $content,
            'data-property' => @$sectionElement['property'],
            'data-target' => $sectionElement['data-target'],
            'class' => @$config['class'],
        );
        if (isset($sectionElement['description']) && !empty($sectionElement['description'])) {
            $params['description'] = $sectionElement['description'];
        }
        $return .= OTW_Form::text_input($params);
        $return .= '</td>
                </tr>';

        return $return;
    }
}

if (!function_exists('otw_admin_slider')) {
    function otw_admin_slider($content, $sectionElementKey, $sectionElement, $config = array())
    {
        $return = '
        <tr valign="top">
            <th scope="row">
                <label for="' . $sectionElement['linkedElement'] . '">' . $sectionElement['label'] . '</label>
            </th>
        <td>';
        if (!isset($content['button_style'][$sectionElementKey]) && !isset($config['value'])) {
            $content['button_style'][$sectionElementKey] = 0;
        }
        if (!isset($content['sub_button_style'][$sectionElementKey]) && !isset($config['value'])) {
            $content['sub_button_style'][$sectionElementKey] = 0;
        }
        if (!isset($config['target'])) {
            $config['target'] = 'stylePx';
        }
        if (!isset($config['measures'])) {
            $config['measures'] = 'px';
        }
        $section = 'button_style';
        // @todo - refactor if/elseif/elseif....
        if (isset($sectionElement['section']) && $sectionElement['section'] === 'sub_button_style') {
            $section = 'sub_button_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'upper_button_style') {
            $section = 'upper_button_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'sub_button_hover_style') {
            $section = 'sub_button_hover_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'upper_button_hover_style') {
            $section = 'upper_button_hover_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'button_background') {
            $section = 'button_background';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'button_parent_style') {
            $section = 'button_parent_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'button_icon_box') {
            $section = 'button_icon_box';
        } else if (isset($sectionElement['section'])) {
            $section = 'button_hover_style';
        }

        $value = '';
        if (isset($content[$section][$sectionElementKey]) && trim($content[$section][$sectionElementKey]) !== '') {
            $value = $content[$section][$sectionElementKey];
        } else if (isset($config['value']) && trim($config['value']) !== '') {
            $value = $config['value'];
        }

        $params = array(
            'id' => $sectionElement['linkedElement'],
            'value' => $value,
            'property' => $sectionElement['property'],
            'slider' => array(
                'id' => $sectionElement['sliderId'],
                'width' => $sectionElement['width'],
                'linkedElement' => $sectionElement['linkedElement'],
                'min' => $sectionElement['sliderMin'],
                'max' => $sectionElement['sliderMax'],
                'step' => $sectionElement['sliderStep'],
                'target' => $config['target'],
                'measures' => $config['measures'],
                'section' => $section,
            ),
        );
        if (isset($config['group'])) {
            $params['group'] = $config['group'];
        }
        if (isset($config['auto']) && $content[$section][$sectionElementKey] == 'auto') {
            $params['auto'] = true;
            $config['auto']['checked'] = 'checked';
        }
        if (isset($sectionElement['description']) && !empty($sectionElement['description'])) {
            $params['description'] = $sectionElement['description'];
        }
        if (isset($config['auto'])) {
            $return .= OTW_Form::checkbox($config['auto']);
        }
        if (isset($sectionElement['name']) && !empty($sectionElement['name'])) {
            $params['name'] = $sectionElement['name'];
        }
        $return .= OTW_Form::slider($params);

        $return .= '</td>
                </tr>';

        return $return;
    }
}

if (!function_exists('otw_admin_drop_down')) {
    function otw_admin_drop_down($content, $sectionElementKey, $sectionElement, $config = array())
    {
        global $buttonTypes, $chosenButtonType;
        $options = $config['options'];
        if (is_string($config['options'])) {
            $options = $buttonTypes[$chosenButtonType][$config['options']];
        }
        
        $return = '
        <tr valign="top">
            <th scope="row">
                <label for="' . $sectionElement['id'] . '">' . $sectionElement['label'] . '</label>
            </th>
        <td>';
        $params = array(
            'id' => $sectionElement['id'],
            'name' => $sectionElement['name'],
            'options' => $options,
            'value' => @$config['value'],
            'data-property' => $sectionElement['property'],
            'data-target' => $sectionElement['data-target'],
            'autocomplete' => 'off',
            'class' => @$config['class'],
            'format' => @$config['format'],
        );
        if (isset($sectionElement['description']) && !empty($sectionElement['description'])) {
            $params['description'] = $sectionElement['description'];
        }
        $return .= OTW_Form::select($params);
        $return .= '</td>
                </tr>';

        return $return;
    }
}

if (!function_exists('otw_admin_color_picker')) {
    function otw_admin_color_picker($content, $sectionElementKey, $sectionElement, $config = array())
    {
        $return = '
        <tr valign="top">
            <th scope="row">
                <label for="' . $sectionElement['id'] . '">' . $sectionElement['label'] . '</label>
            </th>
        <td>';

        if (isset($sectionElement['section']) && $sectionElement['section'] === 'sub_button_style') {
            $section = 'sub_button_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'upper_button_style') {
            $section = 'upper_button_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'sub_button_hover_style') {
            $section = 'sub_button_hover_style';
        } else if (isset($sectionElement['section']) && $sectionElement['section'] === 'upper_button_hover_style') {
            $section = 'upper_button_hover_style';
        } else if (isset($sectionElement['section'])) {
            $section = 'button_hover_style';
        }

        if (!isset($config['value']) && isset($content[$section][$sectionElementKey])) {
            $config['value'] = $content[$section][$sectionElementKey];
        } else if (!isset($config['value']) && isset($content[$section][$sectionElement['property']])) {
            $config['value'] = $content[$section][$sectionElement['property']];
        }
        if (isset($config['value']) && !empty($config['value'])) {
            $config['value'] = str_replace('!important', '', $config['value']);
        }

        $params = array(
            'id' => $sectionElement['id'],
            'name' => $sectionElement['name'],
            'value' => @$config['value'],
            'data-property' => $sectionElement['property'],
            'data-target' => $sectionElement['data-target'],
            'data-group' => @$sectionElement['data-group'],
            'autocomplete' => 'off',
            'section' => $section,
        );
        
        if (isset($sectionElement['data-group'])) {
            $params['data-group'] = $sectionElement['data-group'];
        }
        if (isset($sectionElement['description']) && !empty($sectionElement['description'])) {
            $params['description'] = $sectionElement['description'];
        }
        $params['format'] = 'with_selector';
        $return .= OTW_Form::color_picker($params);
        $return .= '</td>
                </tr>';

        return $return;
    }
}

if (!function_exists('otw_admin_checkbox')) {
    function otw_admin_checkbox($content, $sectionElementKey, $sectionElement, $config = array())
    {
        $return = '
        <tr valign="top">
            <th scope="row">
                <label for="' . $sectionElement['id'] . '">' . $sectionElement['label'] . '</label>
            </th>
        <td>';
        $dataId = $sectionElement['id'];
        if (isset($sectionElement['data-id'])) {
            $dataId = $sectionElement['data-id'];
        }

        $parse = $content['button_style'];
        if (strpos($sectionElement['id'], 'sub_') !== false && isset($content['sub_button_style'])) {
            $parse = $content['sub_button_style'];
        }
        if (strpos($sectionElement['id'], 'upper_') !== false && isset($content['upper_button_style'])) {
            $parse = $content['upper_button_style'];
        }
        
        $params = array(
            'id' => $sectionElement['id'],
            'name' => $sectionElement['name'],
            'value' => @$sectionElement['value'],
            'data-property' => $sectionElement['property'],
            'data-value' => $sectionElement['value'],
            'data-target' => $sectionElement['data-target'],
            'data-id' => $dataId,
            'autocomplete' => 'off',
            'parse' => $parse,
        );
        
        if (isset($sectionElement['description']) && !empty($sectionElement['description'])) {
            $params['description'] = $sectionElement['description'];
        }
        
        $return .= OTW_Form::checkbox($params);
        $return .= '</td>
                </tr>';

        return $return;
    }
}

if (!function_exists('otw_admin_uploader')) {
    function otw_admin_uploader($content, $sectionElementKey, $sectionElement, $config = array())
    {
        $return = '
        <tr valign="top">
            <th scope="row">
                <label for="' . $sectionElement['id'] . '">' . $sectionElement['label'] . '</label>
            </th>
        <td>';
        $dataId = $sectionElement['id'];
        if (isset($sectionElement['data-id'])) {
            $dataId = $sectionElement['data-id'];
        }
        $params = array(
            'id' => $sectionElement['id'],
            'name' => $sectionElement['name'],
            'value' => @$sectionElement['value'],
            'data-property' => $sectionElement['property'],
            'data-target' => $sectionElement['data-target'],
            'data-id' => $dataId,
            'autocomplete' => 'off',
            'parse' => $content,
        );
        if (isset($sectionElement['description']) && !empty($sectionElement['description'])) {
            $params['description'] = $sectionElement['description'];
        }
        $return .= OTW_Form::uploader($params);
        $return .= '</td>
                </tr>';

        return $return;
    }
}

add_action( 'wp_ajax_otw_bmp_button_live_preview', 'otw_bpm_live_preview_callback' );

if (!function_exists('otw_bpm_live_preview_callback')) {
	function otw_bpm_live_preview_callback(){
		
		global $buttonTypes, $chosenButtonType, $prev_db_button;
		
		$otw_button_id = 0;
		$db_button = array();
		$db_button['id'] = $otw_button_id;
		
		if( isset( $_POST['type'] ) ){
		
			$chosenButtonType = $_POST['type'];
		}
		
		$prev_db_button = otw_bmp_parse_post_variables( $db_button, $otw_button_id );
		
		echo do_shortcode( '[otw-bmp id="'.$otw_button_id.'" admin_preview="1"]' );
		die;
	}
}

if (!function_exists('otw_bmp_parse_post_variables')) {
	function otw_bmp_parse_post_variables( $db_button, $otw_button_id ){
		
		global $chosenButtonType, $otwPluginDevName, $buttonTypes;
		
                $db_button['type'] = (string)$chosenButtonType;
                $db_button['button_name'] = (string)otw_stripslashes($_POST['button_name']);
                $db_button['button_title'] = (string)otw_stripslashes($_POST['button_title']);
                $db_button['sub_button_title'] = (string)otw_stripslashes(@$_POST['sub_button_title']);
                $db_button['upper_button_title'] = (string)otw_stripslashes(@$_POST['upper_button_title']);
                $db_button['button_icon'] = (string)otw_stripslashes($_POST['button_icon']);
                $db_button['button_icon_position'] = (string)otw_stripslashes($_POST['button_icon_position']);
                if (isset($_POST['icon_url'])) {
                    $db_button['icon_url'] = (string)otw_stripslashes($_POST['icon_url']);
                } else {
                    $db_button['icon_url'] = '';
                }
                $db_button['button_href'] = (string)otw_stripslashes($_POST['button_href']);
                $db_button['button_target'] = (string)otw_stripslashes($_POST['button_target']);
                $db_button['button_class'] = (string)otw_stripslashes($_POST['button_class']);
                $db_button['animation_on_load_hover'] = (string)otw_stripslashes($_POST['animation_on_load_hover']);
                $db_button['animation_button_class'] = (string)otw_stripslashes($_POST['animation_button_class']);
                $db_button['button_background'] = (string)otw_stripslashes(serialize($_POST['button_background']));
                $buttonTypes[$chosenButtonType]['default_classes'][] = $otwPluginDevName . '_' . $otw_button_id;
                $db_button['button_additional_classes'] = join(' ', $buttonTypes[$chosenButtonType]['default_classes']);

                if (!empty($_POST['additional-classes'])) {
                    $db_button['button_additional_classes'] .= ' ' . join(' ', $_POST['additional-classes']);
                }

                $css = '.' . $otwPluginDevName . '_' . $otw_button_id . ' {';
                if (isset($_POST['button_style'])) {
                    if (isset($_POST['width-auto']) && $_POST['width-auto'] =='on') {
                        $_POST['button_style']['width'] = 'auto';
                    }
                    foreach ($_POST['button_style'] as $cssProperty => $cssValue) {
                    
                	if( in_array( $cssProperty, array( 'color', 'font-size', 'text-shadow', 'font-style', 'font-weight', 'text-transform' ) ) ){
            			continue;
            		}
                        if (!is_array($cssValue)) {
                            $cssValue = array($cssValue);
                        }
                        $i = 0;
                        foreach ($cssValue as $name => $itemValue) {
                            if ($cssProperty === 'text-shadow' && $name === 'color' && $itemValue === '') {
                                $itemValue = '#ffffff';
                            }
                            if (trim($itemValue) === '') {
                                continue;
                            }
                            if (is_numeric($itemValue)) {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue . 'px';
                            } else {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue;
                            }
                            if ($i >= (count($cssValue) - 1)) {
                                $css .= ' !important; ';
                            }
                            $i++;
                        }
                    }
                }
                if ($_POST['button_background']['background-type'] == 'common') {
                    $css .= 'background-color: ' . $_POST['button_background']['background-color'] . ' !important;';
                } else if ($_POST['button_background']['background-type'] == 'linear-gradient') {
                    foreach (array('linear-gradient', '-moz-linear-gradient', '-webkit-linear-gradient', '-o-linear-gradient') as $gradient) {
                        $css .= 'background: ' . $gradient . '(';
                        $css .= $_POST['button_background']['background-angle'] . 'deg, ';
                        $css .= $_POST['button_background']['background-start-color'] . ' ';
                        $css .= $_POST['button_background']['background-reach-from'] . '%, ';
                        $css .= $_POST['button_background']['background-end-color'] . ' ';
                        $css .= $_POST['button_background']['background-reach-to'] . '%';
                        $css .= ') !important;';
                    }
                } else if ($_POST['button_background']['background-type'] == 'radial-gradient') {
                    foreach (array('radial-gradient', '-moz-radial-gradient', '-webkit-radial-gradient', '-o-radial-gradient') as $gradient) {
                        $css .= 'background: ' . $gradient . '(center, ellipse cover, ';
                        $css .= $_POST['button_background']['background-start-color'] . ' ';
                        $css .= $_POST['button_background']['background-reach-from'] . '%, ';
                        $css .= $_POST['button_background']['background-end-color'] . ' ';
                        $css .= $_POST['button_background']['background-reach-to'] . '%';
                        $css .= ') !important;';
                    }
                }
                $css .= '}';
                
                $css .= ' .' . $otwPluginDevName . '_' . $otw_button_id . ' .otw-bmp-content > span {';
                if (isset($_POST['button_style'])) {
            	    foreach ($_POST['button_style'] as $cssProperty => $cssValue) {
            	    
            		if( !in_array( $cssProperty, array( 'color', 'font-size', 'text-shadow', 'font-style', 'font-weight', 'text-transform' ) ) ){
            			continue;
            		}
                        if (!is_array($cssValue)) {
                            $cssValue = array($cssValue);
                        }
                        $i = 0;
                        foreach ($cssValue as $name => $itemValue) {
                            if ($cssProperty === 'text-shadow' && $name === 'color' && $itemValue === '') {
                                $itemValue = '#ffffff';
                            }
                            if (trim($itemValue) === '') {
                                continue;
                            }
                            if (is_numeric($itemValue)) {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue . 'px';
                            } else {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue;
                            }
                            if ($i >= (count($cssValue) - 1)) {
                                $css .= ' !important; ';
                            }
                            $i++;
                        }
                    }
                }
                $css .= '}';
                $db_button['button_style'] = (string)otw_stripslashes($css);

                $buttonMap = array(
                    'download-button' => 'download',
                    'button-builder' => 'button-builder',
                );
                $css = '.parent_' . $otwPluginDevName . '_' . $otw_button_id . ' .otw-bmp-' . $buttonMap[$chosenButtonType] . '-lower {';
                
                if (isset($_POST['sub_button_style'])) {
                    if (isset($_POST['width-auto']) && $_POST['width-auto'] =='on') {
                        $_POST['sub_button_style']['width'] = 'auto';
                    }
                    
			if( !isset( $_POST['sub_button_style']['font-style'] ) || ( $_POST['sub_button_style']['font-style'] == '' ) ){
				$_POST['sub_button_style']['font-style'] = 'normal';
			}
			if( !isset( $_POST['sub_button_style']['font-weight'] ) || ( $_POST['sub_button_style']['font-weight'] == '' ) ){
				$_POST['sub_button_style']['font-weight'] = 'normal';
			}
			if( !isset( $_POST['sub_button_style']['text-transform'] ) || ( $_POST['sub_button_style']['text-transform'] == '' ) ){
				$_POST['sub_button_style']['text-transform'] = 'none';
			}
                    
                    foreach ($_POST['sub_button_style'] as $cssProperty => $cssValue) {
                        if (!is_array($cssValue)) {
                            $cssValue = array($cssValue);
                        }
                        $i = 0; $has_style = false;
                        foreach ($cssValue as $name => $itemValue) {
                            
				if( $itemValue === '' ){
					
					switch( $name ){
						
						case 'font-weight':
								$itemValue = 'normal';
							break;
						case 'font-style':
								$itemValue = 'normal';
							break;
						case 'text-transform':
								$itemValue = 'none';
							break;
					}
				}
				
                            if (trim($itemValue) === '' || trim($cssProperty === 'width')) {
                                //continue;
                            }else{
                            $has_style = true;
                            if (is_numeric($itemValue)) {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue . 'px';
                            } else {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue;
                            }
                            }
                            if ($i >= (count($cssValue) - 1)) {
                        	if( $has_style ){
                            	    $css .= ' !important; ';
                                }
                            }
                            $i++;
                        }
                    }
                }
                $css .= '}';
                $db_button['sub_button_style'] = (string)otw_stripslashes($css);

                $css = '.parent_' . $otwPluginDevName . '_' . $otw_button_id . ' .otw-bmp-' . $buttonMap[$chosenButtonType] . '-upper {';
                if (isset($_POST['upper_button_style'])) {
                    if (isset($_POST['width-auto']) && $_POST['width-auto'] =='on') {
                        $_POST['upper_button_style']['width'] = 'auto';
                    }
                    foreach ($_POST['upper_button_style'] as $cssProperty => $cssValue) {
                        if (!is_array($cssValue)) {
                            $cssValue = array($cssValue);
                        }
                        $i = 0;
                        foreach ($cssValue as $name => $itemValue) {
                            if (trim($itemValue) === ''|| trim($cssProperty === 'width')) {
                                continue;
                            }
                            if (is_numeric($itemValue)) {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue . 'px';
                            } else {
                                if ($i == 0) {
                                    $css .= $cssProperty . ': ';
                                }
                                $css .= ' ' . $itemValue;
                            }
                            if ($i >= (count($cssValue) - 1)) {
                                $css .= ' !important; ';
                            }
                            $i++;
                        }
                    }
                }
                $css .= '}';
                
                
                $db_button['upper_button_style'] = (string)otw_stripslashes($css);

                $hoverCss = '.parent_' . $otwPluginDevName . '_' . $otw_button_id . ':hover  .otw-bmp-' . $buttonMap[$chosenButtonType] . '-lower {';
                if (isset($_POST['sub_button_hover_style'])) {
                    foreach ($_POST['sub_button_hover_style'] as $cssHoverProperty => $cssHoverValue) {
                        $cssHoverValue = str_replace(' !important', '', $cssHoverValue);
                        if (trim($cssHoverValue) === '') {
                            continue;
                        }
                        if (is_numeric($cssHoverValue) && $cssHoverProperty !== 'opacity') {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . 'px !important;';
                        } else {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . ' !important;';
                        }
                    }
                }
                $hoverCss .= '}';
                $db_button['sub_button_hover_style'] = (string)otw_stripslashes($hoverCss);

                $hoverCss = '.' . $otwPluginDevName . '_' . $otw_button_id . ':hover {';
                if (isset($_POST['button_hover_style'])) {
                    foreach ($_POST['button_hover_style'] as $cssHoverProperty => $cssHoverValue) {
                    
                	if( in_array( $cssHoverProperty, array( 'color', 'font-size', 'text-shadow', 'font-style', 'font-weight', 'text-transform' ) ) ){
            			continue;
            		}
                    
                        $cssHoverValue = str_replace(' !important', '', $cssHoverValue);
                        if (trim($cssHoverValue) === '') {
                            continue;
                        }
                        if (is_numeric($cssHoverValue) && $cssHoverProperty !== 'opacity') {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . ' !important;';
                        } else {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . ' !important;';
                        }
                    }
                }
                $hoverCss .= '}';
                $hoverCss .= '.' . $otwPluginDevName . '_' . $otw_button_id . ':hover .otw-bmp-content > span{';
                if (isset($_POST['button_hover_style'])) {
                    foreach ($_POST['button_hover_style'] as $cssHoverProperty => $cssHoverValue) {
                    
                	if( !in_array( $cssHoverProperty, array( 'color', 'font-size', 'text-shadow', 'font-style', 'font-weight', 'text-transform' ) ) ){
            			continue;
            		}
                        $cssHoverValue = str_replace(' !important', '', $cssHoverValue);
                        if (trim($cssHoverValue) === '') {
                            continue;
                        }
                        if (is_numeric($cssHoverValue) && $cssHoverProperty !== 'opacity') {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . ' !important;';
                        } else {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . ' !important;';
                        }
                    }
                }
                $hoverCss .= '}';
                $db_button['button_hover_style'] = (string)otw_stripslashes($hoverCss);

                $hoverCss = '.parent_' . $otwPluginDevName . '_' . $otw_button_id . ':hover .otw-bmp-' . $buttonMap[$chosenButtonType] . '-upper {';
                if (isset($_POST['upper_button_hover_style'])) {
                    foreach ($_POST['upper_button_hover_style'] as $cssHoverProperty => $cssHoverValue) {
                        $cssHoverValue = str_replace(' !important', '', $cssHoverValue);
                        if (trim($cssHoverValue) === '') {
                            continue;
                        }
                        if (is_numeric($cssHoverValue) && $cssHoverProperty !== 'opacity') {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . ' !important;';
                        } else {
                            $hoverCss .= $cssHoverProperty . ': ' . $cssHoverValue . ' !important;';
                        }
                    }
                }
                $hoverCss .= '}';
                $db_button['upper_button_hover_style'] = (string)otw_stripslashes($hoverCss);

                $db_button['font-family'] = (string) otw_stripslashes(@$_POST['button_parent_style']['font-family']);
                $parentCss = '.parent_' . $otwPluginDevName . '_' . $otw_button_id . '{';
                if (isset($_POST['button_parent_style'])) {
                    foreach ($_POST['button_parent_style'] as $parentCssProperty => $parentCssValue) {
                        if (!is_array($parentCssValue)) {
                            $parentCssValue = array($parentCssValue);
                        }
                        $i = 0;
                        foreach ($parentCssValue as $name => $itemValue) {
                            if ($parentCssProperty === 'box-shadow' && $name === 'color' && $itemValue === '') {
                                $itemValue = '#ffffff';
                            }
                            if (trim($itemValue) === '') {
                                continue;
                            }
                            if (is_numeric($itemValue)) {
                                if ($i == 0) {
                                    $parentCss .= $parentCssProperty . ': ';
                                }
                                $parentCss .= ' ' . $itemValue . 'px';
                            } else {
                                if ($i == 0) {
                                    $parentCss .= $parentCssProperty . ': ';
                                }
                                $parentCss .= ' ' . $itemValue;
                            }
                            if ($i >= (count($parentCssValue) - 1)) {
                                $parentCss .= ' !important; ';
                            }
                            $i++;
                        }
                    }

                    if (isset($_POST['button_style']['border-radius'])) {
                        $parentCss .= 'border-radius: ' . $_POST['button_style']['border-radius'] . 'px !important;';
                    }
                }
                $parentCss .= '}';
                $db_button['button_parent_style'] = (string)otw_stripslashes($parentCss);

                $iconBoxCss = '.' . $otwPluginDevName . '_' . $otw_button_id . ' i.fa {';
                if (isset($_POST['button_icon_box'])) {
                    foreach ($_POST['button_icon_box'] as $iconBoxCssProperty => $iconBoxCssValue) {
                        if (!is_array($iconBoxCssValue)) {
                            $iconBoxCssValue = array($iconBoxCssValue);
                        }
                        $i = 0;
                        foreach ($iconBoxCssValue as $name => $itemValue) {
                            if ($iconBoxCssProperty === 'box-shadow' && $name === 'color' && $itemValue === '') {
                                $itemValue = '#ffffff';
                            }
                            if (trim($itemValue) === '') {
                                continue;
                            }
                            if (is_numeric($itemValue)) {
                                if ($i == 0) {
                                    $iconBoxCss .= $iconBoxCssProperty . ': ';
                                }
                                $iconBoxCss .= ' ' . $itemValue . 'px';
                            } else {
                                if ($i == 0) {
                                    $iconBoxCss .= $iconBoxCssProperty . ': ';
                                }
                                $iconBoxCss .= ' ' . $itemValue;
                            }
                            if ($i >= (count($iconBoxCssValue) - 1)) {
                                $iconBoxCss .= ' !important; ';
                            }
                            $i++;
                        }
                    }

                    if (isset($_POST['button_icon_box']['border-radius'])) {
                        $iconBoxCss .= '-webkit-border-radius: ' . $_POST['button_icon_box']['border-radius'] . 'px !important;';
                        $iconBoxCss .= '-moz-border-radius: ' . $_POST['button_icon_box']['border-radius'] . 'px !important;';
                    }
                }
                if( isset( $_POST['button_style'] ) && isset( $_POST['button_style']['color'] ) && $_POST['button_style']['color'] ){
            	    $iconBoxCss.= 'color: '.$_POST['button_style']['color'].' !important;';
                }
                if( isset( $_POST['button_style'] ) && isset( $_POST['button_style']['font-size'] ) && $_POST['button_style']['font-size'] ){
            	    $iconBoxCss.= 'font-size: '.$_POST['button_style']['font-size'].'px !important;';
                }
                
                $iconBoxCss .= '}';
                $db_button['button_icon_box'] = (string)otw_stripslashes($iconBoxCss);

                $db_button['button_parent_class'] = 'parent_' . $otwPluginDevName . '_' . $otw_button_id;
                
                return $db_button;
	}
}

if( !function_exists( 'otw_bmp_factory_message' ) ){
	function otw_bmp_factory_message( $params ){
	
		global $otw_bmp_plugin_id;
		
		if( isset( $params['plugin'] ) && $otw_bmp_plugin_id == $params['plugin'] ){
			
			//filter out some messages if need it
		}
		if( isset( $params['message'] ) )
		{
			return $params['message'];
		}
		return $params;
	}
}