<?php
/**
 * Process otw actions
 *
 */
global $otw_bmp_name, $otwPluginDevName, $optionName, $buttonTypes;
if (isset($_POST[$otwPluginDevName . '_action'])) {
    global $chosenButtonType;

	if( !$otw_bmp_factory_object->is_plugin_active( $otw_bmp_plugin_id ) ){
		
		$validate_messages[] = __( 'The plugin is not activated.', 'otw_bmp' );
		return;
	}

    switch ($_POST[$otwPluginDevName . '_action']) {
	case 'manage_otw_bmp_options':
	
			if( check_admin_referer( 'otw-bmp-options' ) ){
			
				$upload_dir = wp_upload_dir();
				
				if( isset( $upload_dir['basedir'] ) && is_writable( $upload_dir['basedir'] ) ){
					
					global $otw_bmp_custom_css_path;
					
					if( isset( $_POST['otw_bmp_custom_css'] ) && strlen( trim( $_POST['otw_bmp_custom_css'] ) ) ){
					
						if( isset( $upload_dir['basedir'] ) && is_writable( $upload_dir['basedir'] ) ){
							
							if( !is_dir( $upload_dir['basedir'].'/otwbmp' ) ){
								mkdir( $upload_dir['basedir'].'/otwbmp' );
							}
						}
						
						if( is_dir( $upload_dir['basedir'].'/otwbmp' ) && is_writable( $upload_dir['basedir'].'/otwbmp' ) ){
						
							file_put_contents( $otw_bmp_custom_css_path, (string) otw_stripslashes( $_POST['otw_bmp_custom_css'] ) );
						}
					}elseif( file_exists( $otw_bmp_custom_css_path ) ){
						unlink( $otw_bmp_custom_css_path );
					}
				}
				
				if( isset( $_POST['otw_bmp_promotions'] ) && !empty( $_POST['otw_bmp_promotions'] ) ){
					
					global $otw_bmp_factory_object, $otw_bmp_plugin_id;
					
					update_option( $otw_bmp_plugin_id.'_dnms', $_POST['otw_bmp_promotions'] );
					
					if( is_object( $otw_bmp_factory_object ) ){
						$otw_bmp_factory_object->retrive_plungins_data( true );
					}
				}
				
				wp_redirect( admin_url( 'admin.php?page=otw-bmp-settings&message=1' ) );
			}
		break;
        case 'manage_' . $otwPluginDevName:
        
            $otw_bmp_validate_messages = array();
            $valid_page = true;
            if (empty($chosenButtonType)) {
                wp_redirect('admin.php?page=' . $otw_bmp_name . '-add&message=2');
                return;
            }
            if (empty($_POST['button_name'])) {
                wp_redirect('admin.php?page=' . $otw_bmp_name . '-add&type=' . $chosenButtonType . '&message=3');
                return;
            }

            if ($valid_page) {
                $otw_bmp_list = otw_get_buttons();

		$db_button = array();
		
                if (isset($_GET[$otw_bmp_name . '-id'])
                    && isset($otw_bmp_list[$_GET[$otw_bmp_name . '-id']])
                ) {
                    $otw_button_id = $_GET[$otw_bmp_name . '-id'];
                    $db_button = $otw_bmp_list[$_GET[$otw_bmp_name . '-id']];
                } else {
                    $db_button = array(
                        'date_created' => date('Y/m/d'),
                        'user_id' => get_current_user_id(),
                    );
                    $otw_button_id = false;
                }
                
                if ($otw_button_id === false) {
                    $otw_button_id = otw_get_next_button_id();
                    $db_button['id'] = $otw_button_id;
                }
                
                $db_button = otw_bmp_parse_post_variables( $db_button, $otw_button_id );
                
                $db_button['date_modified'] = date('Y/m/d');
                
                
                $otw_bmp_list[$otw_button_id] = $db_button;
                
                global $wpdb;

                if (!update_option($optionName, $otw_bmp_list) && $wpdb->last_error) {
                    $valid_page = false;
                    $otw_bmp_validate_messages[] = __('DB Error: ', $otwPluginDevName) . $wpdb->last_error . '. Tring to save ' . strlen(maybe_serialize($otw_bmp_list)) . ' bytes.';
                } else {
                    wp_redirect('admin.php?page=' . $otw_bmp_name . '-add&button-type=' . $chosenButtonType . '&' . $otw_bmp_name . '-id=' . $otw_button_id . '&message=1');
                }
            }
            break;
        case 'copy_' . $otwPluginDevName:
            if (isset($_POST['cancel'])) {
                wp_redirect('admin.php?page=' . $otw_bmp_name . '-list');
            } else {
                $otw_bmp_list = otw_get_buttons();
                if (isset($_GET[$otw_bmp_name . '-id'])
                    && isset($otw_bmp_list[$_GET[$otw_bmp_name . '-id']])
                ) {
                    $otw_button_id = $_GET[$otw_bmp_name . '-id'];

                    $new_otw_button_id = otw_get_next_button_id();

                    $new_button = $otw_bmp_list[$_GET[$otw_bmp_name . '-id']];
                    $new_button['id'] = $new_otw_button_id;
                    $new_button['button_name'] = __('Copy of ' . $new_button['button_name'], $otwPluginDevName);

                    $otw_bmp_list[$new_button['id']] = $new_button;

                    update_option($optionName, $otw_bmp_list);
                    wp_redirect('admin.php?page=' . $otw_bmp_name . '-list&button-type=' . $chosenButtonType . '&message=5');
                } else {
                    wp_redirect('admin.php?page=' . $otw_bmp_name . '-list&message=6');
                }
            }
            break;
        case 'delete_' . $otwPluginDevName:
            if (isset($_POST['cancel'])) {
                wp_redirect('admin.php?page=' . $otw_bmp_name . '-list');
            } else {
                $otw_bmp_list = otw_get_buttons();

                if (isset($_GET[$otw_bmp_name . '-id'])
                    && isset($otw_bmp_list[$_GET[$otw_bmp_name . '-id']])
                ) {
                    $otw_button_id = $_GET[$otw_bmp_name . '-id'];
                    $new_buttons_list = array();
                    foreach ($otw_bmp_list as $otw_bmp_list_key => $button) {
                        if ($otw_bmp_list_key != $otw_button_id) {
                            $new_buttons_list[$otw_bmp_list_key] = $button;
                        }
                    }
                    update_option($optionName, $new_buttons_list);
                    wp_redirect('admin.php?page=' . $otw_bmp_name . '-list&button-type=' . $chosenButtonType . '&message=2');
                } else {
                    wp_redirect('admin.php?page=' . $otw_bmp_name . '-list&message=6');
                }
            }
            break;
        default:
            break;
    }
}
