<?php

class OTW_Shortcode_OTW_BMP extends OTW_Shortcodes
{
    public function __construct()
    {
        global $shortcodeName;
        $this->has_custom_options = false;
        $this->has_preview = false;
        parent::__construct();
        $this->shortcode_name = $shortcodeName;
    }

    /**
     * apply settings
     */
    public function apply_settings()
    {
        $this->settings = array();
        $this->settings['bmp_options'] = array('' => '---');

        $lists = $otw_lists = otw_get_buttons();
        if (!empty($lists) && is_array($lists)) {
            foreach ($lists as $optionData) {
                if (isset($optionData['id'])) {
                    $this->settings['bmp_options'][$optionData['id']] = $optionData['button_name'];
                }
            }
        }

        $this->settings['default_bmp'] = '';
    }

    /**
     * Shortcode icon_link admin interface
     */
    public function build_shortcode_editor_options()
    {

        $this->apply_settings();

        $html = '';

        $source = array();
        if (isset($_POST['shortcode_object'])) {
            $source = $_POST['shortcode_object'];
        }
        $html .= '<br />';
        $html .= OTW_Form::select(array(
            'id' => 'otw-shortcode-element-id',
            'label' => $this->get_label('Select button'),
            'parse' => $source,
            'options' => $this->settings['bmp_options'],
            'value' => $this->settings['default_bmp'],
        ));

        return $html;
    }

    /** build icon link shortcode
     *
     * @param array
     * @return string
     */
    public function build_shortcode_code($attributes)
    {
        $code = '';

        if (!isset($attributes['id']) || !strlen(trim($attributes['id']))) {
            $this->add_error($this->get_label('Button is required field'));
        }

        if (!$this->has_error) {

            $code = '[' . $this->shortcode_name;

            $code .= $this->format_attribute('id', 'id', $attributes);

            $code .= ']';

        }

        return $code;
    }

    /**
     * Process shortcode icon link
     */
public function display_shortcode($attributes, $content){
	
	$html = '';
	
	$admin_preview = 0;
	
	if( isset( $attributes['admin_preview'] ) && $attributes['admin_preview'] == 1 )
	{
		$admin_preview = 1;
	}
	
	
	if (is_admin() && !$admin_preview ){
		$html = '<img src="' . $this->component_url . 'images/sidebars-icon-placeholder.png' . '" alt=""/>';
	}else{
		
		global $buttonTypes, $googleFontsJson;
		
		$buttonData = array();
		
		if (isset($attributes['id']) && $attributes['id'] ){
			
			$otw_bmp_list = otw_get_buttons();
			
			if (isset($otw_bmp_list[$attributes['id']])) {
				$buttonData = $otw_bmp_list[$attributes['id']];
				
				if( !isset( $buttonData['id'] ) ){
					$buttonData['id'] = $attributes['id'];
				}
				
			}
		}else{
			//get data from global admin var
			global $prev_db_button;
			
			$buttonData = $prev_db_button;
		}
		
		
		if( count( $buttonData ) ){
                
                $html = '';
                if (isset($buttonData['font-family']) && !empty($buttonData['font-family']) && in_array($buttonData['font-family'], json_decode($googleFontsJson, true))) {
                    $html .= "<link rel=\"stylesheet\" type=\"text/css\" href=\"http://fonts.googleapis.com/css?family=" . urlencode($buttonData['font-family']) . "\">" . "\n";
                }
                $html .= '<style type="text/css">';
                // @todo - add in proper files (if better)
                if (isset($buttonData['button_parent_style']) && !empty($buttonData['button_parent_style'])) {
                    $html .= $buttonData['button_parent_style'] . "\n";
                }
                if (isset($buttonData['sub_button_hover_style']) && !empty($buttonData['sub_button_hover_style'])) {
                    $html .= $buttonData['sub_button_hover_style'] . "\n";
                }
                if (isset($buttonData['button_hover_style']) && !empty($buttonData['button_hover_style'])) {
                    $html .= $buttonData['button_hover_style'] . "\n";
                }
                if (isset($buttonData['upper_button_hover_style']) && !empty($buttonData['upper_button_hover_style'])) {
                    $html .= $buttonData['upper_button_hover_style'] . "\n";
                }
                if (isset($buttonData['button_style']) && !empty($buttonData['button_style'])) {
                    $html .= $buttonData['button_style'] . "\n";
                }
                if (isset($buttonData['sub_button_style']) && !empty($buttonData['sub_button_style'])) {
                    $html .= $buttonData['sub_button_style'] . "\n";
                }
                if (isset($buttonData['upper_button_style']) && !empty($buttonData['upper_button_style'])) {
                    $html .= $buttonData['upper_button_style'] . "\n";
                }
                if (isset($buttonData['button_icon_box']) && !empty($buttonData['button_icon_box'])) {
                    $html .= $buttonData['button_icon_box'] . "\n";
                }
                $html = str_replace('opacity: 1 !', 'opacity: 0.99 !', $html);
                $html .= '</style>';
                wp_register_style('otw-bmp-custom-button-css-' . $buttonData['type'],
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
                    'frontend' .
                    DIRECTORY_SEPARATOR .
                    'css' .
                    DIRECTORY_SEPARATOR .
                    'otw-bmp-' . $buttonData['type'] . '.css',
                    false,
                    OTW_BMP_PLUGIN_VERSION,
                    false
                );
                wp_enqueue_style('otw-bmp-custom-button-css-' . $buttonData['type']);

                wp_register_style(
                    'otw-fa',
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
                    'frontend' .
                    DIRECTORY_SEPARATOR .
                    'font-awesome' .
                    DIRECTORY_SEPARATOR .
                    'css' .
                    DIRECTORY_SEPARATOR .
                    'font-awesome.min.css'
                );
                wp_enqueue_style('otw-fa');

                wp_enqueue_style('otw_outer_css_lib_hover',
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
                    'frontend' .
                    DIRECTORY_SEPARATOR .
                    'libs' .
                    DIRECTORY_SEPARATOR .
                    'css' .
                    DIRECTORY_SEPARATOR .
                    'hover.css',
                    false,
                    OTW_BMP_PLUGIN_VERSION,
                    false
                );

                wp_enqueue_style('otw_outer_css_lib_hover_extended',
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
                    'frontend' .
                    DIRECTORY_SEPARATOR .
                    'libs' .
                    DIRECTORY_SEPARATOR .
                    'css' .
                    DIRECTORY_SEPARATOR .
                    'hover-extended.css',
                    false,
                    OTW_BMP_PLUGIN_VERSION,
                    false
                );

                wp_register_script(
                    'otw-bmp-buttons',
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
                    'frontend' .
                    DIRECTORY_SEPARATOR .
                    'js' .
                    DIRECTORY_SEPARATOR .
                    'otw-bmp.js'
                );
                wp_enqueue_script('otw-bmp-buttons');

                if (isset($buttonTypes[$buttonData['type']]['css_files']) && !empty($buttonTypes[$buttonData['type']]['css_files'])) {
                    foreach ($buttonTypes[$buttonData['type']]['css_files'] as $css_file_id => $css_file) {
                        wp_register_style(
                            $css_file_id,
                            plugins_url() .
                            DIRECTORY_SEPARATOR .
                            'otw-buttons-mega-pack' .
                            DIRECTORY_SEPARATOR .
                            'frontend' .
                            DIRECTORY_SEPARATOR .
                            'css' .
                            DIRECTORY_SEPARATOR .
                            $css_file
                        );
                        wp_enqueue_style($css_file_id);
                    }
                }

                $buttonMap = array(
                    'download-button' => 'download',
                    'download-button-content' => 'download-button',
                    'button-builder' => 'button-builder',
                    'button-builder-content' => 'button-builder',
                );

                if (@$buttonData['animation_on_load_hover'] == 'load' && !empty(@$buttonData['animation_button_class'])) {
                    $buttonData['animation_button_class'] .= ' active-on-load';
                }

                if ($buttonData['type'] === 'button-builder') {
                    if (!isset($buttonData['button_additional_classes'])) {
                        $buttonData['button_additional_classes'] = '';
                    }
                    $buttonData['button_additional_classes'] .= ' otw-bmp-button-builder';
                }

                //$html .= '<div class="otw-bmp-hld ' . @$buttonData['button_parent_class'] . ' ' . @$buttonData['animation_button_class'] . '" style="float: left;">';
                
                if( isset( $buttonData['animation_button_class'] ) && preg_match( "/hvr\-bubble/", $buttonData['animation_button_class'] ) )
                {
            		$animation = 'parent';
                }
                elseif( isset( $buttonData['animation_button_class'] ) && preg_match( "/hvr\-icon\-/", $buttonData['animation_button_class'] ) )
                {
            		$animation = 'content';
                }
                else
                {
            		$animation = 'child';
                }
                
                if( $animation == 'parent' )
                {
            	    
            	    $html .= '<div class="otw-bmp-hld ' . @$buttonData['button_parent_class'] . ' ' . @$buttonData['animation_button_class'] . '" style="float: left;">';
            	}
            	else
            	{
            	    $html .= '<div class="otw-bmp-hld ' . @$buttonData['button_parent_class'] . '" style="float: left;">';
            	}
                if (isset($buttonData['button_href'])) {
            	    
            	    if ($buttonData['type'] === 'download-button' && isset($buttonData['upper_button_title']) && !empty($buttonData['upper_button_title'])) {
                        $html .= '<div class="otw-bmp-' . $buttonMap[$buttonData['type']] . '-upper"><span>' . $buttonData['upper_button_title'] . '</span></div>';
                    }
            	    if ( $buttonData['type'] === 'download-button' && isset($buttonData['sub_button_title']) && !empty($buttonData['sub_button_title'])) {
                        $html .= '<div class="otw-bmp-' . $buttonMap[$buttonData['type']] . '-lower"><span>' . $buttonData['sub_button_title'] . '</span></div>';
                    }
                    $buttonTarget = '';
                    if (isset($buttonData['button_target'])) {
                        $buttonTarget = 'target="' . $buttonData['button_target'] . '"';
                    }
                    
                    if( $animation == 'child' )
                    {
                	$html .= '<a id="otw-' . $buttonData['type'] . '-' . $buttonData['id'] . '" href="' . @$buttonData['button_href'] . '" ' . $buttonTarget . ' class="' . @$buttonData['button_additional_classes'] . ' ' . @$buttonData['button_class'] . ' ' . @$buttonData['animation_button_class'] . ' ">';
            	    }
            	    else
            	    {
            		$html .= '<a id="otw-' . $buttonData['type'] . '-' . $buttonData['id'] . '" href="' . @$buttonData['button_href'] . '" ' . $buttonTarget . ' class="' . @$buttonData['button_additional_classes'] . ' ' . @$buttonData['button_class'] . ' ">';
            	    	    
            	    }
                    if (@$buttonData['button_icon_position'] === 'left' && isset($buttonData['button_icon']) && !empty($buttonData['button_icon'])) {
                        $html .= '<i class="fa ' . $buttonData['button_icon'] . '"></i>';
                    }
                    if (@$buttonData['button_icon_position'] === 'left' && isset($buttonData['icon_url']) && !empty($buttonData['icon_url'])) {
//                        $html .= '<i class="fa ' . $buttonData['button_icon'] . '">';
                        $html .= '<img src="' . $buttonData['icon_url'] . '"/>';
//                        $html .= '</i>';
                    }

		    if( $animation == 'content' && isset( $buttonData['animation_button_class'] ) && strlen( $buttonData['animation_button_class'] ) )
		    {
                	$html .= '<div class="otw-bmp-content '.$buttonData['animation_button_class'].'">';
            	    }
            	    else
            	    {
            		$html .= '<div class="otw-bmp-content">';
            	    }

                    /*if ($buttonData['type'] === 'download-button' && isset($buttonData['upper_button_title']) && !empty($buttonData['upper_button_title'])) {
                        $html .= '<span class="otw-bmp-' . $buttonMap[$buttonData['type']] . '-upper">' . $buttonData['upper_button_title'] . '</span>';
                    }*/

                    $html .= '<span class="otw-bmp-' . $buttonMap[$buttonData['type'] . '-content'] . '-content">' . $buttonData['button_title'];
                    
                    if ( $buttonData['type'] !== 'download-button' && isset($buttonData['sub_button_title']) && !empty($buttonData['sub_button_title'])) {
                        $html .= '<div class="otw-bmp-' . $buttonMap[$buttonData['type']] . '-lower"><span>' . $buttonData['sub_button_title'] . '</span></div>';
                    }
                    
                    $html .= "</span>";
                    
                    
                    $html .= '</div>';
                    if (@$buttonData['button_icon_position'] === 'right' && isset($buttonData['button_icon']) && !empty($buttonData['button_icon'])) {
                        $html .= '<i class="fa ' . $buttonData['button_icon'] . '"></i>';
                    }
                    if (@$buttonData['button_icon_position'] === 'right' && isset($buttonData['icon_url']) && !empty($buttonData['icon_url'])) {
//                        $html .= '<i class="fa ' . $buttonData['button_icon'] . '">';
                        $html .= '<img src="' . $buttonData['icon_url'] . '"/>';
//                        $html .= '</i>';
                    }
                    $html .= '</a>';

		    
                    if (@$buttonData['animation_on_load_hover'] == 'load' && !empty(@$buttonData['animation_button_class'])) {
                        $html .= '<script type="text/javascript">';
                        $html .= 'var linkElement = jQuery("#otw-' . $buttonData['type'] . '-' . $buttonData['id'] . '");';
                        $html .= 'var linkImg = jQuery("#otw-' . $buttonData['type'] . '-' . $buttonData['id'] . '").find("img");';
                        $html .= 'if (linkImg.length > 0) { linkImg.css("width", linkImg.width()); linkImg.css("height", linkImg.height()); }';
                        $html .= 'setTimeout(function () {
            			jQuery("#otw-' . $buttonData['type'] . '-' . $buttonData['id'] . '").parent().removeClass("active-on-load");
            			jQuery("#otw-' . $buttonData['type'] . '-' . $buttonData['id'] . '").removeClass("active-on-load");
            			jQuery("#otw-' . $buttonData['type'] . '-' . $buttonData['id'] . '").find( ".otw-bmp-content" ).removeClass("active-on-load");
	                }, 1000);';
                        $html .= '</script>';
                    }
                } else {
                    // @deprecated
                    $html .= '<button href="' . @$buttonData['button_href'] . '" class="' . @$buttonData['button_additional_classes'] . ' ' . @$buttonData['button_class'] . '">';
                    if (isset($buttonData['button_icon']) && !empty($buttonData['button_icon'])) {
                        $html .= '<i class="fa ' . $buttonData['button_icon'] . '"></i>';
                    }
                    if (isset($buttonData['upper_button_title']) && !empty($buttonData['upper_button_title'])) {
                        $html .= '<span class="otw-bmp-' . $buttonMap[$buttonData['type']] . '-upper">' . $buttonData['upper_button_title'] . '</span>';
                    }
                    $html .= $buttonData['button_title'];
                    if (isset($buttonData['sub_button_title']) && !empty($buttonData['sub_button_title'])) {
                        $html .= '<span class="otw-bmp-' . $buttonMap[$buttonData['type']] . '-lower">' . $buttonData['sub_button_title'] . '</span>';
                    }
                    $html .= '</button>';
                }
                $html .= '</div>';
            }
        }

	return $this->format_shortcode_output($html);
}

    /**
     * Build administration form for the button type
     *
     * @return string
     */
    public static function build_admin_form($button_type)
    {
        global $otw_bmp_plugin_root_path;
        return include_once $otw_bmp_plugin_root_path
            . 'include' . DIRECTORY_SEPARATOR
            . 'views' . DIRECTORY_SEPARATOR
            . 'settings' . DIRECTORY_SEPARATOR
            . 'button_style_settings.php';
            // . $button_type . '_settings.php';
    }
}