<?php
global $otw_bmp_name, $otwPluginDevName, $chosenButtonType, $otw_bmp_list, $shortcodeName;
$_wp_column_headers['toplevel_page_' . $otw_bmp_name] = array(
    'button_name' => __('Button Name', $otwPluginDevName),
    'shortcode' => __('Short Code', $otwPluginDevName),
    'type' => __('Button Type', $otwPluginDevName),
    'user_id' => __('Author', $otwPluginDevName),
    'date_created' => __('Created', $otwPluginDevName),
    'date_modified' => __('Modified', $otwPluginDevName),
);

$message = '';
$massages = array();
$messages[1] = __('Button saved.', $otwPluginDevName);
$messages[2] = __('Button deleted.', $otwPluginDevName);
$messages[5] = __('Button copied.', $otwPluginDevName);
$messages[6] = __('Please select button type.', $otwPluginDevName);

if (isset($_GET['message']) && isset($messages[$_GET['message']])) {
    $message .= $messages[$_GET['message']];
}
?>
<?php if ($message) : ?>
    <div id="message" class="updated"><p><?php echo $message; ?></p></div>
<?php endif; ?>
<div class="wrap">
    <div id="icon-edit" class="icon32"></div>
    <h2>
        <?php _e('Buttons', $otwPluginDevName); ?>
        <a class="add-new-h2" href="admin.php?page=otw-bmp-add"><?php _e('Add Button', $otwPluginDevName);?></a>
    </h2>

    <?php
    if (!empty($action['success']) && $action['success'] == 'true') {
        $message = __('Item was saved.', $otwPluginDevName);
        echo '<div class="updated"><p>' . $message . '</p></div>';
    }

    if (!empty($action['success_css']) && $action['success_css'] == 'true') {
        $message = __('Custom CSS file has been updated.', $otwPluginDevName);
        echo '<div class="updated"><p>' . $message . '</p></div>';
    }

    if (!isset($writableError)) {
        $writableError = false;
    }
    if ($writableError) {
        $message = __('The folder \'wp-content/uploads/\' is not writable. Please make sure you add read/write permissions to this folder.', $otwPluginDevName);
        echo '<div class="error"><p>' . $message . '</p></div>';
    }

    if (!isset($writableCssError)) {
        $writableCssError = false;
    }
    if ($writableCssError) {
        if (!defined('SKIN_BM_PATH')) {
            define('SKIN_BM_PATH', 'tmp');
        }
        $message = __('The file \'' . SKIN_BM_PATH . '\' is not writable. Please make sure you add read/write permissions to this file.', $otwPluginDevName);
        echo '<div class="error"><p>' . $message . '</p></div>';
    }

    if (!empty($otw_bmp_list)) {
        ?>

        <table class="widefat fixed" cellspacing="0">
            <thead>
            <tr>
                <?php foreach ($_wp_column_headers['toplevel_page_' . $otw_bmp_name] as $key => $name) { ?>
                    <th><?php echo $name ?></th>
                <?php } ?>
            </tr>
            </thead>
            <tfoot>
            <tr>
                <?php foreach ($_wp_column_headers['toplevel_page_' . $otw_bmp_name] as $key => $name) { ?>
                    <th><?php echo $name ?></th>
                <?php } ?>
            </tr>
            </tfoot>
            <tbody>
            <?php
            $index = 0;
            foreach ($otw_bmp_list as $bmpId => $otw_bmp_item) {
                if (is_array($otw_bmp_item)) {
                    $user_info = get_userdata($otw_bmp_item['user_id']);

                    //Used to add color to even rows
                    $alternate = '';
                    if ($index % 2 == 0) {
                        $alternate = 'class="alternate"';
                    }

                    $edit_link = admin_url('admin.php?page=' . $otw_bmp_name . '-add&amp;button-type=' . $otw_bmp_item['type'] . '&amp;action=edit&amp;' . $otw_bmp_name . '-id=' . $otw_bmp_item['id']);
                    $delete_link = admin_url('admin.php?page=' . $otw_bmp_name . '-list&amp;button-type=' . $otw_bmp_item['type'] . '&amp;action=delete&amp;' . $otw_bmp_name . '-id=' . $otw_bmp_item['id']);
                    $copy_link = admin_url('admin.php?page=' . $otw_bmp_name . '-list&amp;button-type=' . $otw_bmp_item['type'] . '&amp;action=copy&amp;' . $otw_bmp_name . '-id=' . $otw_bmp_item['id']);
                    ?>
                    <tr <?php echo $alternate; ?> >
                        <td>
                            <?php echo '<a href="' . $edit_link . '">' . $otw_bmp_item['button_name'] . '</a>'; ?>
                            <div class="row-actions">
                                <?php
                                echo '<a href="' . $edit_link . '">' . __('Edit', $otwPluginDevName) . '</a>';
                                echo ' | <a href="' . $delete_link . '" data-name="' . $otw_bmp_item['button_name'] . '" class="js-delete-item">' . __('Delete', $otwPluginDevName) . '</a>';
                                echo ' | <a href="' . $copy_link . '" data-name="' . $otw_bmp_item['button_name'] . '" class="js-duplicate-item">' . __('Duplicate', $otwPluginDevName) . '</a>';
                                ?>
                            </div>
                        </td>
                        <td><?php echo '[' . $shortcodeName . ' id="' . $otw_bmp_item['id'] . '"]'; ?></td>
                        <td><?php _e($otw_bmp_item['type'], $otwPluginDevName); ?></td>
                        <td><?php echo $user_info->display_name; ?></td>
                        <td><?php echo $otw_bmp_item['date_created']; ?></td>
                        <td><?php echo $otw_bmp_item['date_modified']; ?></td>
                    </tr>
                    <?php
                    $index++;
                }
            }
            ?>
            </tbody>
        </table>
    <?php } else { ?>
        <p>
            <strong><?php _e('No buttons found.', $otwPluginDevName) ?></strong>
        </p>
    <?php } ?>
</div>
