function otw_bmp_init() {

    jQuery('#post-body-content').otw_bmp_button_builder({
        baseLinkClasses: [
            'otw-bmp-button'
        ],
        iconClasses: [
            'fa'
        ],
        baseClasses: [
            ''
        ],
        classes: [
        ]
    });
}
(function ($) {
    var buttonMap = {
        'download-button': 'download',
        'button-builder': 'button-builder'
    };

    var otw_bmp_button_builder = function (element, options) {
	
        this.element = $(element);
        this.previewSettings = this.element.find('.bmp-accordion-container')
            .find('input, textarea, select, .otw-slider-slide');
        this.previewArea = this.element.closest('#wpbody-content').find('.live_preview');
        this.options = $.extend(
            true, {}, $.fn.otw_bmp_button_builder.defaults, options
        );
    };

    otw_bmp_button_builder.prototype.init = function () {
        var self = this;
        var buttonType = jQuery('#button-type').val();
        if (jQuery("#otw_bmp_type").length > 0) {
            buttonType = jQuery('#otw_bmp_type').val();
        }
        self.options.buttonType = buttonType;

        var baseClasses = self.options.baseClasses.join(' ');
        if ($('#css-classes').length > 0) {
            baseClasses += ' ' + $('#css-classes').val();
        }
        var button = $('<a/>', {
            href: 'javascript:;',
            'class': baseClasses
        });
        var iconClasses = self.options.iconClasses.join(' ');
        if ($('#icon-classes').length > 0) {
            iconClasses += ' ' + $('#icon-classes').val();
        }
        button.append($('<i/>', {
            'class': iconClasses
        }));

        var buttonContent = $('<div/>', {
            'class': 'otw-bmp-content'
        });

        if (self.options.buttonType === 'download-button') {
            buttonContent.prepend($('<span/>', {
                'class': 'otw-bmp-' + buttonMap[self.options.buttonType] + '-upper'
            }));
        }

        buttonContent.append($('<span/>', {
            'class': 'otw-button-builder-content otw-bmp-' + buttonMap[self.options.buttonType] + '-content'
        }));

        buttonContent.append($('<span/>', {
            'class': 'otw-bmp-' + buttonMap[self.options.buttonType] + '-lower'
        }));
        button.append(buttonContent);

        button.hover(function(event) {
            $(this).addClass('otw-hover');
        }, function (event) {
            $(this).removeClass('otw-hover');
        });
        self.previewArea.append(button);
        $.each(this.previewSettings, function () {
            $(this).on('blur scroll change', function (e) {
                self.update_live_preview($(e.currentTarget));
            });
            self.update_live_preview($(this));
        });
        $('.otw-slider-slide').closest('form').on('otw-slider-slide', function (e) {
            self.update_live_preview(jQuery(e.target));
        });

        $(document).on('click', '.auto', function (event) {
            if ($('#' + $(event.currentTarget).data('linkedObjectId')).length <= 0) {
                return;
            }
            var relatedElement = $('#' + $(event.currentTarget).data('linkedObjectId'));
            var relatedSlider = $('#' + $(event.currentTarget).data('linkedSliderId'));
            if ($(event.currentTarget).is(':checked') === true) {
                relatedSlider.parent().hide();
                relatedElement.attr('disabled', 'disabled');
            } else {
                relatedSlider.parent().show();
                relatedElement.removeAttr('disabled');
            }
        });
    };

    otw_bmp_button_builder.prototype.live_preview = function () {

    };

    otw_bmp_button_builder.prototype.update_live_preview = function (element) {
    
        var self = this;
        var property, styleProperty, button;
        var dataTarget = element.data('target');
        switch (dataTarget) {
            case 'text':
            case 'upper_text':
            case 'sub_text':
                button = self.previewArea.find('a');
                if (dataTarget.indexOf('sub_') > -1) {
                    if (button.find('.otw-bmp-' + buttonMap[self.options.buttonType] + '-lower').length > 0) {
                        button.find('.otw-bmp-' + buttonMap[self.options.buttonType] + '-lower').text(element.val());
                    } else {
                        button.append($('<span/>', {
                            'class': '.otw-bmp-' + buttonMap[self.options.buttonType] + '-lower',
                            text: element.val()
                        }));
                    }
                } else {
                    if (button.find('.otw-button-builder-content').length > 0) {
                        button.find('.otw-button-builder-content').text(element.val());
                    } else {
                        button.append($('<span/>', {
                            'class': 'otw-button-builder-content otw-bmp-' + buttonMap[self.options.buttonType] + '-content',
                            text: element.val()
                        }));
                    }
                }
                break;
            // case 'upper_text':
            //     if (self.options.buttonType !== 'download-button') {
            //         return;
            //     }
            //     button = self.previewArea.find('a');
            //     if (button.find('.otw-bmp-' + buttonMap[self.options.buttonType] + '-upper').length > 0) {
            //         button.find('.otw-bmp-' + buttonMap[self.options.buttonType] + '-upper').text(element.val());
            //     } else {
            //         button.append($('<span/>', {
            //             'class': 'otw-bmp-' + buttonMap[self.options.buttonType] + '-upper',
            //             text: element.val()
            //         }));
            //     }
            //     break;
            // case 'sub_title':
            //     button = self.previewArea.find('a');
            //     if (button.find('.otw-bmp-' + buttonMap[self.options.buttonType] + '-lower').length > 0) {
            //         button.find('.otw-bmp-' + buttonMap[self.options.buttonType] + '-lower').text(element.val());
            //     } else {
            //         button.append($('<span/>', {
            //             'class': 'otw-bmp-' + buttonMap[self.options.buttonType] + '-lower',
            //             text: element.val()
            //         }));
            //     }
            //     break;
            case 'href':
                self.previewArea.find('a').attr('href', element.val());
                break;
            case 'class':
                self.previewArea.find('a').removeClass(
                    self.options.classes.join(' ')
                ).addClass(element.val());
                break;
            case 'selectClass': // @deprecated - see if used
                var elementOptions = element.find('option');
                for (var i =0; i < elementOptions.length; i++) {
                    if ($(elementOptions[i]).val().trim() !== '') {
                        self.previewArea.find('a').removeClass($(elementOptions[i]).val());
                    }
                }
                if (element.val().trim() !== '') {
                    self.previewArea.find('a').addClass(element.val().trim());
                }
                break;
            case 'alterClass': // @deprecated - see if used
                if (element.is(':checked') === true) {
                    self.previewArea.find('a').addClass(element.val());
                } else {
                    self.previewArea.find('a').removeClass(element.val());
                }
                break;
            case 'stylePx':
                if (typeof element.data('property') !== 'undefined') {
                    property = element.data('property');
                    styleProperty = {};
                    styleProperty[property] = element.val() + 'px';
                    if (element.attr('id').indexOf('sub_') > -1) {
                        self.previewArea.find('a .otw-bmp-' + buttonMap[self.options.buttonType] + '-lower').css(styleProperty);
                    } else if (element.attr('id').indexOf('content_') > -1) {
                        self.previewArea.find('a .otw-bmp-' + buttonMap[self.options.buttonType] + '-content').css(styleProperty);
                    } else {
                        self.previewArea.find('a').css(styleProperty);
                    }
                }
                break;
            case 'style':
            case 'content_style':
            case 'sub_style':
                if (typeof element.data('property') !== 'undefined') {
                    property = element.data('property');
                    styleProperty = {};
                    styleProperty[property] = element.val();
                    if (dataTarget.indexOf('sub_') > -1) {
                        self.previewArea.find('a .otw-bmp-' + buttonMap[self.options.buttonType] + '-lower').css(styleProperty);
                    } else if (dataTarget.indexOf('content_') > -1) {
                        self.previewArea.find('a .otw-bmp-' + buttonMap[self.options.buttonType] + '-content').css(styleProperty);
                    } else {
                        self.previewArea.find('a').css(styleProperty);
                    }
                }
                break;
            case 'hover-style':
                if (typeof element.data('property') !== 'undefined') {
                    property = element.data('property');
                    var currentStyle = self.parseCSS($('#dynamic-styles').html());
                    var linkHoverStyle = {};
                    if (typeof currentStyle['a.otw-bmp-button:hover'] !== 'undefined') {
                        linkHoverStyle = currentStyle['a.otw-bmp-button:hover'];
                    }
                    linkHoverStyle[property] = element.val();
                    currentStyle['a.otw-bmp-button:hover'] = linkHoverStyle;

                    // @todo - fix to the self.previewArea
                    var style_tag = '<style id="dynamic-styles" type="text/css">' +
                        self.objectToCSS(currentStyle) +
                        '</style>';
                    self.previewArea.parent().find('#dynamic-styles').replaceWith(style_tag);
                }
                break;
            case 'styleOnOff':
            case 'content_styleOnOff':
            case 'sub_styleOnOff':
                if (typeof element.data('property') !== 'undefined') {
                    property = element.data('property');
                    styleProperty = {};
                    styleProperty[property] = element.val();
                    if (element.is(':checked') === false) {
                        styleProperty[property] = '';
                    }
                    if (dataTarget.indexOf('sub_') > -1) {
                        self.previewArea.find('a .otw-bmp-' + buttonMap[self.options.buttonType] + '-lower').css(styleProperty);
                    } else if (dataTarget.indexOf('content_') > -1) {
                        self.previewArea.find('a .otw-bmp-' + buttonMap[self.options.buttonType] + '-content').css(styleProperty);
                    } else {
                        self.previewArea.find('a').css(styleProperty);
                    }
                }
                break;
            case 'icon':
                button = self.previewArea.find('a');
                if (element.val() !== '') {
                    if (
                        $('[data-target="icon_url"]').length > 0
                        && $('[data-target="icon_url"]').val() !== ''
                    ) {
                        var conf = confirm('There is Icon URL set, would you like to remove it?');
                        if (conf === true) {
                            $('[data-target="icon_url"]').val('');
                            if (button.find('i>img').length > 0) {
                                button.find('i>img').remove();
                            }
                        } else {
                            return;
                        }
                    }
                    if (button.find('i.fa').length > 0) {
                        button.find('i.fa').attr('class', 'fa ' + element.val());
                    } else {
                        button.prepend($('<i/>', {
                            'class': 'fa ' + element.val()
                        }));
                    }
                } else {
                    button.find('i.fa').remove();
                }
                break;
            case 'icon_url':
                button = self.previewArea.find('a');
                var iconPosition = false;
                if ($('[data-target="iconPosition"]').length > 0 && $('[data-target="iconPosition"]').val() !== '') {
                    iconPosition = $('[data-target="iconPosition"]').val();
                }
                if (element.val() !== '') {
                    if ($('[data-target="icon"]').length > 0) {
                        $('[data-target="icon"]').val('');
                    }
                    if (button.find('i').length > 0) {
                        var prefix = "fa-";
                        var classes = button.find('i')[0].className.split(" ").filter(function(c) {
                            return c.lastIndexOf(prefix, 0) !== 0;
                        });
                        button.find('i')[0].className = classes.join(" ").trim();
                        if (button.find('i>img').length == 0) {
                            if (iconPosition === 'right') {
                                button.find('i').append($('<img/>', {
                                    src: element.val()
                                }));
                            } else {
                                button.find('i').prepend($('<img/>', {
                                    src: element.val()
                                }));
                            }
                        } else {
                            button.find('i>img').attr(src, element.val());
                        }
                    } else {
                        if (iconPosition === 'right') {
                            button.append($('<i/>', {
                                'class': 'fa',
                                html: $('<img/>', {
                                    src: element.val()
                                })
                            }));
                        } else {
                            button.prepend($('<i/>', {
                                'class': 'fa',
                                html: $('<img/>', {
                                    src: element.val()
                                })
                            }));
                        }
                    }
                } else {
                    if (button.find('i').length > 0) {
                        if (button.find('i>img').length > 0) {
                            button.find('i>img').remove();
                        }
                        button.find('i').removeAttr('style');
                        if ($('[data-target="icon"]').length > 0) {
                            button.find('i').attr('class', 'fa ' + $('[data-target="icon"]').val());
                        }
                    } else {
                        button.prepend($('<i/>', {
                            'class': 'fa ' + $('[data-target="icon"]').val()
                        }));
                    }
                }
                break;
            case 'iconPosition':
                button = self.previewArea.find('a');
                if (button.find('i.fa').length > 0) {
                    var icon = button.find('i.fa');
                    button.find('i.fa').remove();
                    if (element.val() == 'left') {
                        button.prepend(icon);
                    } else {
                        button.append(icon);
                    }
                }
                break;
            case 'parent-style':
                if (typeof element.data('property') !== 'undefined') {
                    property = element.data('property');
                    styleProperty = {};
                    styleProperty[property] = element.val();
                    if (property == 'font-family') {
                        var fontsArray = JSON.parse(fonts);
                        if (typeof fontsArray[element.val()] !== 'undefined') {
                            styleProperty[property] = fontsArray[element.val()].text;
                        }
                    }
                    self.previewArea.find('a').parent().css(styleProperty);
                }
                break;
            default:
                break;
        }
    };

    otw_bmp_button_builder.prototype.parseCSS = function(css) {
        var rules = {};
        css = this.removeComments(css);
        var blocks = css.split('}');
        blocks.pop();
        var len = blocks.length;
        for (var i = 0; i < len; i++)
        {
            var pair = blocks[i].split('{');
            rules[$.trim(pair[0])] = this.parseCSSBlock(pair[1]);
        }
        return rules;
    };

    otw_bmp_button_builder.prototype.parseCSSBlock = function(css) {
        var rule = {};
        var declarations = css.split(';');
        declarations.pop();
        var len = declarations.length;
        for (var i = 0; i < len; i++)
        {
            var loc = declarations[i].indexOf(':');
            var property = $.trim(declarations[i].substring(0, loc));
            var value = $.trim(declarations[i].substring(loc + 1));
            value = value.replace(' !important', '');

            if (property != "" && value != "")
                rule[property] = value;
        }
        return rule;
    };

    otw_bmp_button_builder.prototype.objectToCSS = function (input) {
        var cssString = '';
        $.each(input, function (index, element) {
            cssString += index + ' { ';
            $.each(element, function (property, value) {
                cssString += property + ': ' + value + ' !important; ';
            })
            cssString += ' } ';
        });
        return cssString;
    };

    otw_bmp_button_builder.prototype.removeComments = function(css) {
        return css.replace(/\/\*(\r|\n|.)*\*\//g,"");
    };

    otw_bmp_button_builder.prototype.live_reload = function () {

    };

    $.fn.otw_bmp_button_builder = createPlugin(
        'otw_bmp_button_builder',
        otw_bmp_button_builder, {}
    );

    function createPlugin(dataName, constructor, defaults) {
        var plugin = function (options) {
            if (options === 'instance') {
                return this.data(dataName);
            }
            if (options === 'destroy') {
                return this.each(function () {
                    var self = $(this), instance = self.data(dataName);
                    if (instance) {
                        instance.destroy();
                    }
                    self.removeData(dataName);
                });
            }
            return this.each(function () {
                var self = $(this);
                if (self.data(dataName)) {
                    // Already initialized
                    return;
                }
                var instance = new constructor(this, options);
                self.data(dataName, instance);
                instance.init();
            });
        };
        plugin.defaults = defaults;
        return plugin;
    }
})(jQuery);
