(function ($) {
    var otw_bmp_button = function (element, options) {
        this.element = $(element);
        this.previewSettings = this.element.find('.bmp-accordion-container').find('input, textarea, select, .otw-slider-slide');
        this.previewArea = this.element.closest('#wpbody-content').find('.live_preview');
        this.xhrPreviewArea = this.element.closest('#wpbody-content').find('#otw_bmp_live_preview');
        this.options = $.extend(
            true, {}, $.fn.otw_bmp_button.defaults, options
        );
    };

    otw_bmp_button.prototype.init = function () {
        var self = this;

        var button = self.initButton();

        $.each(self.options.methods, function (methodName, method) {
            if (typeof self[methodName] !== 'function') {
                self[methodName] = method;
            }
        });

        $.each(this.previewSettings, function () {
            $(this).on('blur scroll change', function (e) {
                if (typeof $(e.currentTarget).data('target') !== 'undefined' && typeof self[$(e.currentTarget).data('target')] === 'function') {
                    self[$(e.currentTarget).data('target')]($(e.currentTarget), button);
                }
            });

            if (typeof $(this).data('target') !== 'undefined' && typeof self[$(this).data('target')] === 'function') {
                self[$(this).data('target')]($(this), button);
            }
        });
        $('.otw-slider-slide').closest('form').on('otw-slider-slide', function (e) {
            if (typeof $(e.target).data('target') !== 'undefined' && typeof self[$(e.target).data('target')] === 'function') {
                self[$(e.target).data('target')]($(e.target), button);
            }
        });

        $(document).on('click', '.auto', function (event) {
            if ($('#' + $(event.currentTarget).data('linkedObjectId')).length <= 0) {
                return;
            }
            var relatedElement = $('#' + $(event.currentTarget).data('linkedObjectId'));
            var relatedSlider = $('#' + $(event.currentTarget).data('linkedSliderId'));
            if ($(event.currentTarget).is(':checked') === true) {
                relatedSlider.parent().hide();
                relatedElement.attr('disabled', 'disabled');
            } else {
                relatedSlider.parent().show();
                relatedElement.removeAttr('disabled');
            }
        });
    };

    otw_bmp_button.prototype.initButton = function () {
	return;
        var self = this;
        var buttonType = jQuery('#button-type').val();
        if (jQuery("#otw_bmp_type").length > 0) {
            buttonType = jQuery('#otw_bmp_type').val();
        }
        self.options.buttonType = buttonType;

        var baseClasses = self.options.baseClasses.join(' ');
        if ($('#css-classes').length > 0) {
            baseClasses += ' ' + $('#css-classes').val();
        }
        var button = $('<a/>', {
            href: 'javascript:;',
            'class': baseClasses
        });
        var iconClasses = self.options.iconClasses.join(' ');
        if ($('#icon-classes').length > 0) {
            iconClasses += ' ' + $('#icon-classes').val();
        }
        button.append($('<i/>', {
            'class': iconClasses
        }));

        var buttonContent = $('<div/>', {
            'class': 'otw-bmp-content'
        });

        if (self.options.buttonType === 'download-button') {
            buttonContent.prepend($('<span/>', {
                'class': self.options.upperClass
            }));
        }

        buttonContent.append($('<span/>', {
            'class': self.options.contentClass
        }));

        buttonContent.append($('<span/>', {
            'class': self.options.lowerClass
        }));
        button.append(buttonContent);

        button.hover(function(event) {
            $(this).addClass('otw-hover');
        }, function (event) {
            $(this).removeClass('otw-hover');
        });
        self.previewArea.append($('<div/>', {
            id: 'otw-link-holder'
        }));
        self.previewArea.find('#otw-link-holder').append(button);

        return button;
    };

    otw_bmp_button.prototype.text = function (element, button) {
        var self = this;
        button = self.previewArea.find('a');
        if (button.find('.' + self.options.contentClass).length > 0) {
            button.find('.' + self.options.contentClass).text(element.val());
        } else {
            button.append($('<span/>', {
                'class': 'otw-button-builder-content ' + self.options.contentClass,
                text: element.val()
            }));
        }
    };

    otw_bmp_button.prototype.sub_text = function (element, button) {
        var self = this;
        button = self.previewArea.find('a');
        if (button.find('.' + self.options.lowerClass).length > 0) {
            button.find('.' + self.options.lowerClass).text(element.val());
        } else {
            button.append($('<span/>', {
                'class': '.' + self.options.lowerClass,
                text: element.val()
            }));
        }
    };

    otw_bmp_button.prototype.href = function (element, button) {
        var self = this;
        self.previewArea.find('a').attr('href', element.val());
    };

    otw_bmp_button.prototype.class = function (element, button) {
        var self = this;
        self.previewArea.find('a').removeClass(
            self.options.classes.join(' ')
        ).addClass(element.val());
    };

    otw_bmp_button.prototype.animationClass = function (element, button) {
        var self = this;
        self.previewArea.find('a').parent().removeClass(
            animationClasses.join(' ')
        ).addClass(element.val());
        if (element.val().trim() !== '' && $('#animation_on_load_hover').val().length > 0 && $('#animation_on_load_hover').val().trim() === 'load') {
            self.previewArea.find('a').parent().addClass('active-on-load');
            setTimeout(function () {
                self.previewArea.find('a').parent().removeClass('active-on-load');
            }, 1000);
        }
    };

    otw_bmp_button.prototype.animationClassOnLoad = function (element, button) {
        var self = this;
        
        if (element.val() === 'load') {
            self.previewArea.find('a').parent().addClass('active-on-load');
            setTimeout(function () {
                self.previewArea.find('a').parent().removeClass('active-on-load');
            }, 1000);
            
            self.xhrPreviewArea.find('a').parent().addClass('active-on-load');
            setTimeout(function () {
                self.xhrPreviewArea.find('a').parent().removeClass('active-on-load');
            }, 1000);
        } else {
            self.previewArea.find('a').parent().removeClass('active-on-load');
        }
    };

    // @deprecated
    otw_bmp_button.prototype.selectClass = function (element, button) {
        var self = this;
        var elementOptions = element.find('option');
        for (var i = 0; i < elementOptions.length; i++) {
            if ($(elementOptions[i]).val().trim() !== '') {
                self.previewArea.find('a').removeClass($(elementOptions[i]).val());
            }
        }
        if (element.val().trim() !== '') {
            self.previewArea.find('a').addClass(element.val().trim());
        }
    };

    otw_bmp_button.prototype.alterClass = function (element, button) {
        var self = this;
        if (element.is(':checked') === true) {
            self.previewArea.find('a').addClass(element.val());
        } else {
            self.previewArea.find('a').removeClass(element.val());
        }
    };

    otw_bmp_button.prototype.stylePx = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val() + 'px';
            if (element.attr('id').indexOf('sub_') > -1) {
                self.previewArea.find('a .' + self.options.lowerClass).css(styleProperty);
            } else if (element.attr('id').indexOf('upper_') > -1) {
                self.previewArea.find('a .' + self.options.upperClass).css(styleProperty);
            } else if (element.attr('id').indexOf('content_') > -1) {
                self.previewArea.find('a .' + self.options.contentClass).css(styleProperty);
            } else {
                self.previewArea.find('a').css(styleProperty);
            }

            if (element.data('property') === 'border-radius' && document.getElementById('button_border_radius')) {
                var borderRadius = document.getElementById('button_border_radius').value;
                self.previewArea.find('#otw-link-holder').css('border-radius', borderRadius + 'px');
            }
        }
    };

    otw_bmp_button.prototype.parentStylePx = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val() + 'px';
            self.previewArea.find('#otw-link-holder').css(styleProperty);
        }
    };

    otw_bmp_button.prototype.button_icon_box_styling = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            if (isNaN(element.val()) === false) {
                styleProperty[property] += 'px';
            }
            if (element.val() === '' || element.val().toLowerCase() === 'none' || element.val().toLowerCase() === 'inherit') {
                self.previewArea.find('a i.fa').css(property, '');
            } else {
                self.previewArea.find('a i.fa').css(styleProperty);
            }
        }
    };

    otw_bmp_button.prototype.style = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            self.previewArea.find('a').css(styleProperty);
        }
    };

    otw_bmp_button.prototype.background = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};

            var startColor = '';
            var endColor = '';
            var reachFrom = '';
            var reachTo = '';
            var gradient = '';
            if ($('#button_background_type').val() === 'linear-gradient') {
                $('[data-group="linear-gradient"]').closest('tr').removeClass('inactive').show();
                $('[data-group="gradient"]').closest('tr').removeClass('inactive').show();
                $('[data-group="common"]').closest('tr').addClass('inactive').hide();
                self.previewArea.find('a').css('background-color', '');
                self.previewArea.find('a').css('background', '');

                startColor = document.getElementById("button_background_start_color").value;
                endColor = document.getElementById("button_background_end_color").value;
                reachFrom = document.getElementById("button_reach_from").value;
                reachTo = document.getElementById("button_reach_to").value;
                var angle = document.getElementById("button_angle").value;
                gradient = angle + 'deg, ' + startColor + ' ' + reachFrom + '%, ' + endColor + ' ' + reachTo + '%';

                self.previewArea.find('a').css('background', 'linear-gradient(' + gradient + ')');
                self.previewArea.find('a').css('background', '-moz-linear-gradient(' + gradient + ')');
                self.previewArea.find('a').css('background', '-webkit-linear-gradient(' + gradient + ')');
                self.previewArea.find('a').css('background', '-o-linear-gradient(' + gradient + ')');
                // styleProperty['background'] = linearGradient;
            } else if ($('#button_background_type').val() === 'radial-gradient') {
                $('[data-group="gradient"]').closest('tr').removeClass('inactive').show();
                $('[data-group="linear-gradient"]').closest('tr').addClass('inactive').hide();
                $('[data-group="common"]').closest('tr').addClass('inactive').hide();
                self.previewArea.find('a').css('background-color', '');
                self.previewArea.find('a').css('background', '');

                startColor = document.getElementById("button_background_start_color").value;
                endColor = document.getElementById("button_background_end_color").value;
                reachFrom = document.getElementById("button_reach_from").value;
                reachTo = document.getElementById("button_reach_to").value;

                gradient = 'center, ellipse cover, ' + startColor + ' ' + reachFrom + '%, ' + endColor + ' ' + reachTo + '%';

                self.previewArea.find('a').css('background', 'radial-gradient(' + gradient + ')');
                self.previewArea.find('a').css('background', '-moz-radial-gradient(' + gradient + ')');
                self.previewArea.find('a').css('background', '-webkit-radial-gradient(' + gradient + ')');
                self.previewArea.find('a').css('background', '-o-radial-gradient(' + gradient + ')');
                // styleProperty['background'] = radialGradient;
            } else {
                $('[data-group="common"]').closest('tr').removeClass('inactive').show();
                $('[data-group="gradient"]').closest('tr').addClass('inactive').hide();
                $('[data-group="linear-gradient"]').closest('tr').addClass('inactive').hide();
                self.previewArea.find('a').css('background', '');
                self.previewArea.find('a').css('background-color', $('#button_background_color').val());
            }
        }
    };

    otw_bmp_button.prototype.content_style = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            self.previewArea.find('a .' + self.options.contentClass).css(styleProperty);

            if (property.trim() === 'color' && self.previewArea.find('a i').length > 0) {
                self.previewArea.find('a i').css('color', element.val());
            }
        }
    };

    otw_bmp_button.prototype.text_shadow = function (element, button) {
        var self = this;

        var theShadow = "";
        var shadowHOffset = "";
        var shadowVOffset = "";
        var shadowBlur = "";
        var shadowColor = "";

        shadowHOffset = document.getElementById("button_text_shadow_h").value;
        shadowVOffset = document.getElementById("button_text_shadow_v").value;
        shadowBlur = document.getElementById("button_text_shadow_b").value;
        shadowColor = document.getElementById("button_text_shadow_color").value;

        if (theShadow === "") {
            theShadow = shadowHOffset + "px " + shadowVOffset + "px " + shadowBlur + "px " + shadowColor;
        } else {
            // theShadow = theShadow + ", " + shadowHOffset + "px " + shadowVOffset + "px " + shadowBlur + "px " + shadowColor;
        }
        var styleProperty = {};
        styleProperty['textShadow'] = theShadow;

        self.previewArea.find('a .' + self.options.contentClass).css(styleProperty);
    };

    otw_bmp_button.prototype.sub_text_shadow = function (element, button) {
        var self = this;

        var theShadow = "";

        var shadowHOffset = document.getElementById("sub_button_text_shadow_h").value;
        var shadowVOffset = document.getElementById("sub_button_text_shadow_v").value;
        var shadowBlur = document.getElementById("sub_button_text_shadow_b").value;
        var shadowColor = document.getElementById("sub_button_text_shadow_color").value;

        if (theShadow === "") {
            theShadow = shadowHOffset + "px " + shadowVOffset + "px " + shadowBlur + "px " + shadowColor;
        }
        var styleProperty = {};
        styleProperty['textShadow'] = theShadow;

        self.previewArea.find('a .' + self.options.lowerClass).css(styleProperty);
    };

    otw_bmp_button.prototype.box_shadow = function (element, button) {
        var self = this;
        var theShadow = "";

        var shadowHOffset = document.getElementById("button_box_shadow_h").value;
        var shadowVOffset = document.getElementById("button_box_shadow_v").value;
        var shadowBlur = document.getElementById("button_box_shadow_b").value;
        var shadowColor = document.getElementById("button_box_shadow_color").value;

        if (theShadow === ""){
            theShadow = shadowHOffset + "px " + shadowVOffset + "px " + shadowBlur + "px " + shadowColor;
        }
        var styleProperty = {};
        styleProperty['webkitBoxShadow'] = theShadow;
        styleProperty['MozBoxShadow'] = theShadow;
        styleProperty['boxShadow'] = theShadow;

        if (document.getElementById('button_border_radius')) {
            var borderRadius = document.getElementById('button_border_radius').value;
            styleProperty['webkitBorderRadius'] = borderRadius + 'px';
            styleProperty['MozBorderRadius'] = borderRadius + 'px';
            styleProperty['borderRadius'] = borderRadius + 'px';
        }

        self.previewArea.find('#otw-link-holder').css(styleProperty);
    };

    otw_bmp_button.prototype.sub_style = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            self.previewArea.find('a .' + self.options.lowerClass).css(styleProperty);
        }
    };

    otw_bmp_button.prototype.sub_hover_style = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var currentStyle = self.parseCSS($('#dynamic-sub-styles').html());
            var linkHoverStyle = {};
            if (typeof currentStyle['a.otw-bmp-button:hover .' + self.options.lowerClass] !== 'undefined') {
                linkHoverStyle = currentStyle['a.otw-bmp-button:hover .' + self.options.lowerClass];
            }
            linkHoverStyle[property] = element.val();
            currentStyle['a.otw-bmp-button:hover .' + self.options.lowerClass] = linkHoverStyle;

            // @todo - fix to the self.previewArea
            var style_tag = '<style id="dynamic-sub-styles" type="text/css">' +
                self.objectToCSS(currentStyle) +
                '</style>';
            self.previewArea.parent().find('#dynamic-sub-styles').replaceWith(style_tag);
        }
    };

    otw_bmp_button.prototype.hover_style = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var currentStyle = self.parseCSS($('#dynamic-styles').html());
            var linkHoverStyle = {};
            var additionalClass = '';
            if (property === 'color') {
                additionalClass = ' .' + self.options.contentClass;
            }
            if (typeof currentStyle['a.otw-bmp-button:hover' + additionalClass] !== 'undefined') {
                linkHoverStyle = currentStyle['a.otw-bmp-button:hover' + additionalClass];
            }
            linkHoverStyle[property] = element.val();
            currentStyle['a.otw-bmp-button:hover' + additionalClass] = linkHoverStyle;

            // @todo - fix to the self.previewArea
            var style_tag = '<style id="dynamic-styles" type="text/css">' +
                self.objectToCSS(currentStyle) +
                '</style>';
            self.previewArea.parent().find('#dynamic-styles').replaceWith(style_tag);
        }
    };

    otw_bmp_button.prototype.styleOnOff = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            if (element.is(':checked') === false) {
                styleProperty[property] = '';
            }
            self.previewArea.find('a').css(styleProperty);
        }
    };

    otw_bmp_button.prototype.content_styleOnOff = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            if (element.is(':checked') === false) {
                styleProperty[property] = '';
            }
            self.previewArea.find('a .' + self.options.contentClass).css(styleProperty);
        }
    };

    otw_bmp_button.prototype.sub_styleOnOff = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            if (element.is(':checked') === false) {
                styleProperty[property] = '';
            }
            self.previewArea.find('a .' + self.options.lowerClass).css(styleProperty);
        }
    };

    otw_bmp_button.prototype.icon = function (element, button) {
        var self = this;
        button = self.previewArea.find('a');
        if (element.val() !== '') {
            if (
                $('[data-target="icon_url"]').length > 0
                && $('[data-target="icon_url"]').val() !== ''
            ) {
                var conf = confirm('There is Icon URL set, would you like to remove it?');
                if (conf === true) {
                    $('[data-target="icon_url"]').val('');
                    if (button.find('i>img').length > 0) {
                        button.find('i>img').remove();
                    }
                } else {
                    return;
                }
            }
            if (button.find('i.fa').length > 0) {
                button.find('i.fa').attr('class', 'fa ' + element.val());
            } else {
                button.prepend($('<i/>', {
                    'class': 'fa ' + element.val()
                }));
            }
        } else {
            button.find('i.fa').remove();
        }

        $.each($('[data-target="button_icon_box_styling"]'), function (index, el) {
            self.button_icon_box_styling($(el), button);
        });
    };

    otw_bmp_button.prototype.icon_url = function (element, button) {
        var self = this;
        button = self.previewArea.find('a');
        var iconPosition = false;
        if ($('[data-target="iconPosition"]').length > 0 && $('[data-target="iconPosition"]').val() !== '') {
            iconPosition = $('[data-target="iconPosition"]').val();
        }
        if (element.val() !== '') {
            if ($('[data-target="icon"]').length > 0) {
                $('[data-target="icon"]').val('');
            }
            if (button.find('i').length > 0) {
                var prefix = "fa-";
                var classes = button.find('i')[0].className.split(" ").filter(function(c) {
                    return c.lastIndexOf(prefix, 0) !== 0;
                });
                button.find('i')[0].className = classes.join(" ").trim();
                if (button.find('i>img').length == 0) {
                    if (iconPosition === 'right') {
                        button.find('i').append($('<img/>', {
                            src: element.val()
                        }));
                    } else {
                        button.find('i').prepend($('<img/>', {
                            src: element.val()
                        }));
                    }
                } else {
                    button.find('i>img').attr(src, element.val());
                }
            } else {
                if (iconPosition === 'right') {
                    button.append($('<i/>', {
                        'class': 'fa',
                        html: $('<img/>', {
                            src: element.val()
                        })
                    }));
                } else {
                    button.prepend($('<i/>', {
                        'class': 'fa',
                        html: $('<img/>', {
                            src: element.val()
                        })
                    }));
                }
            }
            $.each($('[data-target="button_icon_box_styling"]'), function (index, el) {
                self.button_icon_box_styling($(el), button);
            });
        } else {
            if (button.find('i').length > 0) {
                if (button.find('i>img').length > 0) {
                    button.find('i>img').remove();
                }
                if ($('[data-target="icon"]').length > 0) {
                    button.find('i').attr('class', 'fa ' + $('[data-target="icon"]').val());
                }
            } else if ($('[data-target="icon"]').val() !== '') {
                button.prepend($('<i/>', {
                    'class': 'fa ' + $('[data-target="icon"]').val()
                }));
            }
        }
    };

    otw_bmp_button.prototype.iconPosition = function (element, button) {
        var self = this;
        button = self.previewArea.find('a');
        if (button.find('i.fa').length > 0) {
            var icon = button.find('i.fa');
            button.find('i.fa').remove();
            if (element.val() == 'left') {
                button.prepend(icon);
            } else {
                button.append(icon);
            }
        }
    };

    otw_bmp_button.prototype.parent_style = function (element, button) {
        var self = this;
        if (typeof element.data('property') !== 'undefined') {
            var property = element.data('property');
            var styleProperty = {};
            styleProperty[property] = element.val();
            if (property == 'font-family' && element.val().trim() !== '' && googleFontsJson.indexOf(element.val()) > 0) {
                var googleFont = 'http://fonts.googleapis.com/css?family=' + encodeURIComponent(element.val());
                $('#google-font').attr('href', googleFont);
            }
            self.previewArea.find('a').parent().css(styleProperty);
        }
    };

    otw_bmp_button.prototype.parseCSS = function(css) {
        var rules = {};
        css = this.removeComments(css);
        var blocks = css.split('}');
        blocks.pop();
        var len = blocks.length;
        for (var i = 0; i < len; i++)
        {
            var pair = blocks[i].split('{');
            rules[$.trim(pair[0])] = this.parseCSSBlock(pair[1]);
        }
        return rules;
    };

    otw_bmp_button.prototype.parseCSSBlock = function(css) {
        var rule = {};
        var declarations = css.split(';');
        declarations.pop();
        var len = declarations.length;
        for (var i = 0; i < len; i++)
        {
            var loc = declarations[i].indexOf(':');
            var property = $.trim(declarations[i].substring(0, loc));
            var value = $.trim(declarations[i].substring(loc + 1));
            value = value.replace(' !important', '');

            if (property != "" && value != "")
                rule[property] = value;
        }
        return rule;
    };

    otw_bmp_button.prototype.objectToCSS = function (input) {
        var cssString = '';
        $.each(input, function (index, element) {
            cssString += index + ' { ';
            $.each(element, function (property, value) {
                cssString += property + ': ' + value + ' !important; ';
            })
            cssString += ' } ';
        });
        return cssString;
    };

    otw_bmp_button.prototype.removeComments = function(css) {
        return css.replace(/\/\*(\r|\n|.)*\*\//g,"");
    };

    otw_bmp_button.prototype.live_reload = function () {

    };

    $.fn.otw_bmp_button = createPlugin(
        'otw_bmp_button',
        otw_bmp_button, {}
    );

    function createPlugin(dataName, constructor, defaults) {
        var plugin = function (options) {
            if (options === 'instance') {
                return this.data(dataName);
            }
            if (options === 'destroy') {
                return this.each(function () {
                    var self = $(this), instance = self.data(dataName);
                    if (instance) {
                        instance.destroy();
                    }
                    self.removeData(dataName);
                });
            }
            return this.each(function () {
                var self = $(this);
                if (self.data(dataName)) {
                    // Already initialized
                    return;
                }
                var instance = new constructor(this, options);
                self.data(dataName, instance);
                instance.init();
            });
        };
        plugin.defaults = defaults;
        return plugin;
    }
})(jQuery);