var $ = jQuery.noConflict(); //Wordpress by default uses jQuery instead of $

jQuery(document).ready(function () {
    var $ = jQuery.noConflict();

    reInitContent();
    
    initLivePreview();
});

function reInitContent() {

    jQuery('.bmp-accordion-container').accordion({
        header: "> ul > li > h3",
        collapsible: true,
        heightStyle: 'content',
        speed: 'fast'
    });

    if (typeof otw_bmp_init === 'function') {
        otw_bmp_init();
    }

    // Leave this under otw_bmp initialization so there is actual button to disable
    jQuery('#otw_bmp_live_preview').find('a').click(function (e) {
        e.preventDefault();
        e.stopPropagation();
    });

    jQuery.each(jQuery(".otw-slider-slide"), function () {
        var elementData = jQuery(this).data();
        var linkedElement = jQuery("#" + jQuery(this).data('linkedElement'));
        var sliderValue = linkedElement.val();
        var sliderMin = elementData.sliderMin;
        var sliderMax = elementData.sliderMax;
        var sliderStep = elementData.sliderStep;
        jQuery(this).slider({
            value: sliderValue,
            min: sliderMin, // todo - add in config
            max: sliderMax, // todo - add in config
            step: sliderStep, // todo - add in config
            slide: function (event, ui) {
                jQuery(this).closest('.otw-slider-wrapper').find('div.otw-slider-preview-value>span').html(ui.value);
                linkedElement.val(ui.value);
                
                linkedElement.trigger('otw-slider-slide');
            },
            change: function(event, ui) {
        	linkedElement.change();
            }
        });
    });

    jQuery('.js-fonts').select2();
    jQuery('.js-icons').select2({
        formatResult: format,
        formatSelection: format,
        escapeMarkup: function (m) {
            return m;
        }
    });

    jQuery(".otw-bmp-color-palette").select2({
        formatResult: formatColorPicker,
        formatSelection: formatColorPicker,
        escapeMarkup: function (m) {
            return m;
        }
    }).on('change.select2', function(event) {
        var targetElement = jQuery('#' + jQuery(event.currentTarget).data('targetElement'));
        if (targetElement.length > 0) {
            targetElement.val(event.val).focus().blur();
            targetElement.siblings().find('div.otw-color-holder').css('background-color', event.val);
        }
    });
    
	jQuery('#button_background_type').change( function(){
	
		switch( this.value ){
			case 'linear-gradient':
					jQuery('[data-group="linear-gradient"]').closest('tr').removeClass('inactive').show();
					jQuery('[data-group="gradient"]').closest('tr').removeClass('inactive').show();
					jQuery('[data-group="common"]').closest('tr').addClass('inactive').hide();
				break;
			case 'radial-gradient':
					jQuery('[data-group="gradient"]').closest('tr').removeClass('inactive').show();
					jQuery('[data-group="linear-gradient"]').closest('tr').addClass('inactive').hide();
					jQuery('[data-group="common"]').closest('tr').addClass('inactive').hide();
				break;
			case 'common':
					jQuery('[data-group="common"]').closest('tr').removeClass('inactive').show();
					jQuery('[data-group="gradient"]').closest('tr').addClass('inactive').hide();
					jQuery('[data-group="linear-gradient"]').closest('tr').addClass('inactive').hide();
				break;
		};
	} );
}

function format(option) {
    if (!option.id)
        return option.text; // optgroup
    return "<i class='fa " + option.id + "'></i> " + option.text;
}

function formatColorPicker(option) {
    if (!option.id || typeof option.id === 'undefined' || option.id === '') { return option.text; }
    var $state = jQuery(
        '<div><div style="display: inline-block; width: 15px; height: 10px; margin-right: 10px; background-color: ' + option.id.toLowerCase() + '"></div>' + option.text + '</div>'
    );
    return $state;
}

function livePreviewElementVal( form_element ){
	
	switch( form_element.attr( 'type' ) )
	{
		case 'checkbox':
		
				if( form_element.attr( 'checked' ) ){
					return form_element.val();
				}else{
					return '';
				}
			break;
		default:
				return form_element.val();
			break;
	}
}

function initLivePreview(){
	
	var live_container = jQuery( '#otw_bmp_live_preview' );
	
	//collect the values
	var elements = jQuery( '#post-body-content' ).find( 'input,select,textarea' );
	var s_code = {};
	
	for( var cE = 0; cE < elements.length; cE++ ){
	
		var form_element = jQuery( elements[ cE ] );
		
		if( !form_element.attr( 'data-lp' ) ){
			
			form_element.change( function(){
				
				initLivePreview();
			} );
			form_element.attr( 'data-lp', 1234 );
		}
		
		var element_name = form_element.attr( 'name' );
		
		if( typeof( element_name ) != 'undefined' ){
		
			var matches = false;
			
			if( matches = element_name.match( /([a-zA-Z\_\-]+)(\[([^\]]*)\]+)/ ) ){
				var var_name = matches[1];
				
				var sub_var_1 = matches[3]
				
				if( typeof( s_code[ var_name ] ) == 'undefined' ){
				
					s_code[ var_name ] = {};
				}
				
				if( typeof( s_code[ var_name ][ sub_var_1 ] ) == 'undefined' ){
				
					s_code[ var_name ][ sub_var_1 ] = {};
				}
				
				//remove sub var form string
				var new_name = element_name.replace( matches[2], '' );
				
				var sub_matches = false;
				if( sub_matches = new_name.match( /([a-zA-Z\_\-]+)(\[([^\]]*)\]+)/ ) ){
				
					var sub_var_2 = sub_matches[3];
					
					if( typeof( s_code[ var_name ][ sub_var_1 ][ sub_var_2 ] ) == 'undefined' ){
					
						s_code[ var_name ][ sub_var_1 ][ sub_var_2 ] = {};
					}
					s_code[ var_name ][ sub_var_1 ][ sub_var_2 ] = livePreviewElementVal( form_element );
				}
				else{
				
					s_code[ var_name ][ sub_var_1 ] = livePreviewElementVal( form_element );
				}
			}else{
				
				switch( element_name ){
				
					case 'otw_bmp_action':
					case 'submit-otw-bmp':
							//skipp
						break;
					case 'type':
					default:
							s_code[ element_name ] = livePreviewElementVal( form_element );
						break;
				}
			}
		}
	}
	
	var preview_loader = jQuery( '#otw_bmp_live_preview_loader' );
	
	preview_loader.show();
	
	jQuery.post( 'admin-ajax.php?action=otw_bmp_button_live_preview' , s_code, function( response ){
	
		live_container.html( response );
		
		preview_loader.hide();
		
		var settings_node = jQuery( '.otw-settings-preview-holder' );
		
		//fix the preview if too big
		var p_content = jQuery('.bmp-live_preview-container');
		
		var parent_height = p_content.parent().height() + 60;
		
		/*p_content.height( live_container.height() );*/
		
		if( settings_node.html().length )
		{
			p_content.show();
			
			var top = p_content.parent().offset().top;
			var width = p_content.parent().width();
			
			jQuery(window).scroll(function (event){
				
				var width = p_content.parent().width();
				
				p_content.width( width );
				if( parent_height < jQuery( window ).height() )
				{
					var y = jQuery(this).scrollTop();
					
					if (y >= top){
					
						p_content.addClass( 'otw-sticky-preview' );
						
					}else{
						p_content.removeClass( 'otw-sticky-preview' );
					}
				}
				else{
					p_content.removeClass( 'otw-sticky-preview' );
				}
			});
			
			if( parent_height < jQuery( window ).height() ){
			
				var y = jQuery(window).scrollTop();
				
				if (y >= top){
				
					p_content.addClass( 'otw-sticky-preview' );
					p_content.width( width );
				}else{
					p_content.removeClass( 'otw-sticky-preview' );
				}
			}else{
				p_content.removeClass( 'otw-sticky-preview' );
			}
			/*
			var p_bottom = p_content.position().top + p_content.height();
			
			if( jQuery(window.top).height() < p_bottom ){
				
				p_content.css( 'position', 'unset' );
			}else{
				p_content.height( jQuery(window.top).height() );
			}
			*/
			
			jQuery('#otw_bmp_live_preview').find('a').click(function (e) {
				e.preventDefault();
				e.stopPropagation();
			});
		}else{
			p_content.hide();
		}
	});
};