<?php
/**
 * Plugin Name: Buttons Mega Pack
 * Plugin URI: http://OTWthemes.com
 * Description: Create buttons.
 * Author: 20script
 * Version: 2.0
 *
 * Author URI: http://www.20script.ir
 */

load_plugin_textdomain('otw_bmp', false, dirname(plugin_basename(__FILE__)) . '/languages/');

if (!defined('OTW_BMP_PLUGIN_VERSION')) {
    define('OTW_BMP_PLUGIN_VERSION', '1.0.12');
}
$otw_bmp_plugin_id = 'ba64f41cd5f8b34e0df429e3df0e1ced';
$otw_bmp_plugin_url = plugin_dir_url(__FILE__);
$otw_bmp_plugin_root_path = plugin_dir_path(__FILE__);

$otw_bmp_custom_css_path = '';
$otw_bmp_custom_css_url = '';

if( isset( $upload_dir['basedir'] ) ){
	$otw_bmp_custom_css_path = $upload_dir['basedir'].'/otwbmp/custom.css';
	$otw_bmp_custom_css_url =  set_url_scheme( $upload_dir['baseurl'] ).'/otwbmp/custom.css';
}


require_once plugin_dir_path(__FILE__) . '/include/otw_bmp_config.php';

//include functions
require_once(plugin_dir_path(__FILE__) . '/include/otw_bmp_functions.php');

//otw components
$otw_bmp_shortcode_component = false;
$otw_bmp_form_component = false;
$otw_bmp_validator_component = false;
$otw_bmp_factory_component = false;
$otw_bmp_factory_object = false;

//load core component functions
@include_once('include/otw_components/otw_functions/otw_functions.php');

if (!function_exists('otw_register_component')) {
    wp_die('Please include otw components');
}

//register form component
otw_register_component('otw_form', dirname(__FILE__) . '/include/otw_components/otw_form/', $otw_bmp_plugin_url . 'include/otw_components/otw_form/');

//register factory component
otw_register_component( 'otw_factory', dirname( __FILE__ ).'/include/otw_components/otw_factory/', $otw_bmp_plugin_url.'/include/otw_components/otw_factory/' );

//register validator component
otw_register_component('otw_validator', dirname(__FILE__) . '/include/otw_components/otw_validator/', $otw_bmp_plugin_url . 'include/otw_components/otw_validator/');

//register shortcode component
otw_register_component('otw_shortcode', dirname(__FILE__) . '/include/otw_components/otw_shortcode/', $otw_bmp_plugin_url . 'include/otw_components/otw_shortcode/');

if (isset($_GET['generate_icons'])) {
    require_once plugin_dir_path(__FILE__) . '/include/icons.php';
}

/**
 *call init plugin function
 */
global $otwPluginDevName;
add_action('init', 'otw_bmp_init');
add_action('widgets_init', 'otw_bmp_widgets_init');
add_action('admin_enqueue_scripts', 'enqueue_admin_scripts');
add_action('admin_footer', $otwPluginDevName . '_javascript'); // Write our JS below here
add_action('wp_ajax_' . $otwPluginDevName, $otwPluginDevName . '_callback');
add_action('wp_ajax_' . $otwPluginDevName.'_live_preview', $otwPluginDevName . '_live_preview_callback');


function otw_bmp_javascript()
{
    ?>
    <script type="text/javascript">
        jQuery(document).ready(function ($) {
            jQuery('#otw_bmp_type').change(function (event) {
                if (jQuery('.nameErrorMsg').length > 0) {
                    jQuery('.nameErrorMsg').remove();
                }
                if (jQuery('#button_name').val().trim() === '') {
                    jQuery(event.currentTarget).val('');
                    jQuery(event.currentTarget).parent().find('span').html(jQuery(event.currentTarget).find('option[value=""]').html());
                    jQuery('#button_name').addClass('error');
                    jQuery('#message').addClass('error').html($('<p/>',{
                        'text': '<?php echo __('Button name is required.'); ?>'
                    }));
                    return;
                }
                var data = {
                    'action': '<?php global $otwPluginDevName; echo $otwPluginDevName; ?>',
                    'type': jQuery(this).val()
                };

                // todo - figure out a way to clear the field
                // jQuery('.live_preview>a').remove();
                // jQuery('#dynamic-styles').html('');
                jQuery.post(ajaxurl, data, function (response) {
                    jQuery('#ajax-content').html(response);

			initLivePreview();
                    // reInitContent();
                });
            });
        });
    </script> <?php
}

function otw_bmp_callback()
{
    $button_type = $_POST['type'];
    if (!empty($button_type)) {
        global $chosenButtonType, $content;
        $chosenButtonType = $button_type;
        OTW_Shortcode_OTW_BMP::build_admin_form($button_type);
        ?>
        <link rel='stylesheet' href="<?php echo plugins_url() .
            DIRECTORY_SEPARATOR .
            'otw-buttons-mega-pack' .
            DIRECTORY_SEPARATOR .
            'css' .
            DIRECTORY_SEPARATOR .
            'otw_bmp_admin.css?v=' . OTW_BMP_PLUGIN_VERSION; ?>" type='text/css' media='all'/>
        <link rel='stylesheet' href="<?php echo plugins_url() .
            DIRECTORY_SEPARATOR .
            'otw-buttons-mega-pack' .
            DIRECTORY_SEPARATOR .
            'frontend' .
            DIRECTORY_SEPARATOR .
            'css' .
            DIRECTORY_SEPARATOR .
            'otw-bmp-' . $chosenButtonType . '.css?v=' . OTW_BMP_PLUGIN_VERSION; ?>" type='text/css' media='all'/>
        <script src="<?php echo plugins_url() .
            DIRECTORY_SEPARATOR .
            'otw-buttons-mega-pack' .
            DIRECTORY_SEPARATOR .
//            'frontend' .
//            DIRECTORY_SEPARATOR .
            'js' .
            DIRECTORY_SEPARATOR .
            'otw-admin-bmp-abstract-button.js?v=' . OTW_BMP_PLUGIN_VERSION; ?>"></script>
        <script src="<?php echo plugins_url() .
            DIRECTORY_SEPARATOR .
            'otw-buttons-mega-pack' .
            DIRECTORY_SEPARATOR .
//            'frontend' .
//            DIRECTORY_SEPARATOR .
            'js' .
            DIRECTORY_SEPARATOR .
            'otw-admin-bmp-' . $chosenButtonType . '.js?v=' . OTW_BMP_PLUGIN_VERSION; ?>"></script>

        <script src="<?php echo plugins_url() .
            DIRECTORY_SEPARATOR .
            'otw-buttons-mega-pack' .
            DIRECTORY_SEPARATOR .
            'include' .
            DIRECTORY_SEPARATOR .
            'otw_components' .
            DIRECTORY_SEPARATOR .
            'otw_form' .
            DIRECTORY_SEPARATOR .
            'js' .
            DIRECTORY_SEPARATOR .
            'otw_form_admin.js?v=' . OTW_BMP_PLUGIN_VERSION; ?>"></script>
        <script type="text/javascript">
            jQuery(document).ready(function () {
                reInitContent();
            });
        </script>
        <?php
    }
    wp_die();
}

otw_prepare_data();

function enqueue_admin_scripts($requested_page)
{
    if (function_exists('get_current_screen')) {
        $screen = get_current_screen();

        if (isset($screen->id) && strlen($screen->id)) {
            $requested_page = $screen->id;
        }
    }

    global $chosenButtonType, $content;

    if (function_exists('wp_enqueue_media')) {
        wp_enqueue_media(); //WP 3.5 media uploader
    }

    wp_register_style(
        'otw-fa',
        plugins_url() .
        DIRECTORY_SEPARATOR .
        'otw-buttons-mega-pack' .
        DIRECTORY_SEPARATOR .
        'frontend' .
        DIRECTORY_SEPARATOR .
        'font-awesome' .
        DIRECTORY_SEPARATOR .
        'css' .
        DIRECTORY_SEPARATOR .
        'font-awesome.min.css',
        false,
        OTW_BMP_PLUGIN_VERSION
    );
    wp_enqueue_style('otw-fa');

    switch ($requested_page) {
        // todo - define more pages ore move from here
        // case 'toplevel_page_otw-bmp':
        case 'buttons-mega-pack_page_otw-bmp-add':
        case 'otw-ajax':
        case 'post':
            if ($chosenButtonType !== false) {
                wp_register_style(
                    'otw-bmp-' . $chosenButtonType,
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
                    'frontend' .
                    DIRECTORY_SEPARATOR .
                    'css' .
                    DIRECTORY_SEPARATOR .
                    'otw-bmp-' . $chosenButtonType . '.css',
                    false,
                    OTW_BMP_PLUGIN_VERSION
                );
                wp_enqueue_style('otw-bmp-' . $chosenButtonType);

                wp_register_script(
                    'otw-admin-bmp-abstract-button',
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
                    'js' .
                    DIRECTORY_SEPARATOR .
                    'otw-admin-bmp-abstract-button.js',
                    false,
                    OTW_BMP_PLUGIN_VERSION
                );
                wp_enqueue_script('otw-admin-bmp-abstract-button');
                wp_register_script(
                    'otw-admin-bmp-' . $chosenButtonType,
                    plugins_url() .
                    DIRECTORY_SEPARATOR .
                    'otw-buttons-mega-pack' .
                    DIRECTORY_SEPARATOR .
//                    'frontend' .
//                    DIRECTORY_SEPARATOR .
                    'js' .
                    DIRECTORY_SEPARATOR .
//                    'otw-bmp-' . $chosenButtonType . '.js'
                    'otw-admin-bmp-' . $chosenButtonType . '.js',
                    false,
                    OTW_BMP_PLUGIN_VERSION
                );
                wp_enqueue_script('otw-admin-bmp-' . $chosenButtonType);
            }

            wp_register_script(
                'otw-admin-bmp-fonts',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'js' .
                DIRECTORY_SEPARATOR .
                'otw-vars.js',
                false,
                OTW_BMP_PLUGIN_VERSION
            );
            // Custom Scripts + Plugins
            wp_enqueue_script('otw-admin-bmp-fonts');

            wp_register_style(
                'otw-admin-bmp-select2',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'css' .
                DIRECTORY_SEPARATOR . 'select2.css',
                false,
                OTW_BMP_PLUGIN_VERSION
            );
            wp_enqueue_style('otw-admin-bmp-select2');
            wp_register_script('otw-admin-select2',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'js' .
                DIRECTORY_SEPARATOR .
                'select2.js', array('jquery'),
                OTW_BMP_PLUGIN_VERSION
            );
            wp_enqueue_script('otw-admin-select2');

            wp_register_script(
                'otw-admin-bmp-functions',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'js' .
                DIRECTORY_SEPARATOR .
                'otw-admin-bmp-functions.js',
                false,
                OTW_BMP_PLUGIN_VERSION
            );
            // Custom Scripts + Plugins
            wp_enqueue_script('otw-admin-bmp-functions');

            // Core Scripts
            wp_enqueue_script('jquery');
            wp_enqueue_script('jquery-ui-core');
            wp_enqueue_script('jquery-ui-accordion');
            wp_enqueue_script('jquery-ui-slider');

            wp_enqueue_style('otw-bmp-jquery-ui-css',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'css' .
                DIRECTORY_SEPARATOR .
                'jquery-ui.css',
                false,
                OTW_BMP_PLUGIN_VERSION,
                false
            );

            wp_enqueue_style('otw_bmp_admin_css',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'css' .
                DIRECTORY_SEPARATOR .
                'otw_bmp_admin.css',
                false,
                OTW_BMP_PLUGIN_VERSION,
                false
            );

            wp_enqueue_style('otw_outer_css_lib_hover',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'frontend' .
                DIRECTORY_SEPARATOR .
                'libs' .
                DIRECTORY_SEPARATOR .
                'css' .
                DIRECTORY_SEPARATOR .
                'hover.css',
                false,
                OTW_BMP_PLUGIN_VERSION,
                false
            );

            wp_enqueue_style('otw_outer_css_lib_hover_extended',
                plugins_url() .
                DIRECTORY_SEPARATOR .
                'otw-buttons-mega-pack' .
                DIRECTORY_SEPARATOR .
                'frontend' .
                DIRECTORY_SEPARATOR .
                'libs' .
                DIRECTORY_SEPARATOR .
                'css' .
                DIRECTORY_SEPARATOR .
                'hover-extended.css',
                false,
                OTW_BMP_PLUGIN_VERSION,
                false
            );

            break;
    }
}
